# std Namespace Reference

## Classes

- class __ctype_abstract_base
    Common base for ctype facet. More...
- struct __numeric_limits_base
    Part of std::numeric_limits. More...
- struct _Deque_iterator
    A deque::iterator. More...
- struct _List_const_iterator
    A list::const_iterator. More...
- struct _List_iterator
    A list::iterator. More...
- class allocator
    The "standard" allocator, as per [20.4]. More...
- class allocator< void >
    allocator<void> specialization. More...
- class auto_ptr
    A simple smart pointer providing strict ownership semantics. More...
- struct auto_ptr_ref
- class back_insert_iterator
    Turns assignment into insertion. More...
- class bad_alloc
    Exception possibly thrown by `new`. More...
- class bad_cast
    Thrown during incorrect typecasting. More...
- class bad_exception
- class bad_typeid
- class basic_filebuf
    The actual work of input and output (for files). More...
- class basic_fstream
    Controlling intput and output for files. More...
- class basic_ifstream
    Controlling input for files. More...
- class basic_ios
    Virtual base class for all stream classes. More...
- class basic_iostream
    Merging istream and ostream capabilities. More...
- class basic_istream
    Controlling input. More...
- class basic_istringstream
    Controlling input for std::string. More...
- class basic_ofstream
    Controlling output for files. More...
- class basic_ostream
    Controlling output. More...
- class basic_ostringstream
    Controlling output for std::string. More...
- class basic_streambuf
    The actual work of input and output (interface). More...
- class basic_string
    Managing sequences of characters and character-like objects. More...
- class basic_stringbuf
    The actual work of input and output (for std::string). More...
- class basic_stringstream
    Controlling input and output for std::string. More...
- struct bidirectional_iterator_tag
    operations. More...
- struct binary_function
- class binary_negate
    One of the negation functors. More...
- class binder1st
    One of the binder functors. More...
- class binder2nd
    One of the binder functors. More...
- class bitset
    The bitset class represents a fixed-size sequence of bits. More...
- struct char_traits
    Basis for explicit traits specializations. More...
- struct char_traits< __gnu_cxx::character< V, I, S > >
    char_traits<__gnu_cxx::character> specialization. More...
- struct char_traits< char >
    21.1.3.1 char_traits specializations More...
- struct char_traits< wchar_t >
    21.1.3.2 char_traits specializations More...
- class codecvt< _InternT, _ExternT, encoding_state >
    codecvt<InternT, _ExternT, encoding_state> specialization. More...
- class collate
    Facet for localized string comparison. More...
- class collate_byname
    class collate_byname [22.2.4.2]. More...
- class const_mem_fun1_ref_t
    One of the adaptors for member pointers. More...
- class const_mem_fun1_ref_t< void, _Tp, _Arg >
    One of the adaptors for member pointers. More...
- class const_mem_fun1_t
    One of the adaptors for member pointers. More...
- class const_mem_fun1_t< void, _Tp, _Arg >
    One of the adaptors for member pointers. More...
- class const_mem_fun_ref_t
    One of the adaptors for member pointers. More...
- class const_mem_fun_ref_t< void, _Tp >
    One of the adaptors for member pointers. More...
- class const_mem_fun_t
    One of the adaptors for member pointers. More...
- class const_mem_fun_t< void, _Tp >
    One of the adaptors for member pointers. More...
- class ctype
    Template ctype facet. More...
- class ctype< char >
    The ctype<char> specialization. More...
- class ctype< wchar_t >
    The ctype<wchar_t> specialization. More...
- class ctype_byname
    class ctype_byname [22.2.1.2]. More...
- class deque
    A standard container using fixed-size memory allocation and constant-time manipulation of elements at either end. More...
- struct divides
    One of the math functors. More...
- class domain_error
- struct equal_to
    One of the comparison functors. More...
- class exception
    Base class for all library exceptions. More...
- struct forward_iterator_tag
    Forward iterators support a superset of input iterator operations. More...
- class fpos
    Class representing stream positions. More...
- class front_insert_iterator
    Turns assignment into insertion. More...
- struct greater
    One of the comparison functors. More...
- struct greater_equal
    One of the comparison functors. More...
- class gslice
    Class defining multi-dimensional subset of an array. More...
- class gslice_array
    Reference to multi-dimensional subset of an array. More...
- class indirect_array
    Reference to arbitrary subset of an array. More...
- struct input_iterator_tag
    Marking input iterators. More...
- class insert_iterator
    Turns assignment into insertion. More...
- class invalid_argument
- class ios_base
    The base of the I/O class hierarchy. More...
- class istream_iterator
    Provides input iterator semantics for streams. More...
- class istreambuf_iterator
    Provides input iterator semantics for streambufs. More...
- struct iterator
    Common iterator class. More...
- struct iterator_traits
- class length_error
- struct less
    One of the comparison functors. More...
- struct less_equal
    One of the comparison functors. More...
- class list
    A standard container with linear time access to elements, and fixed time insertion/deletion at any point in the sequence. More...
- class locale
    Container class for localization functionality. More...
- class logic_error
    One of two subclasses of exception. More...
- struct logical_and
    One of the Boolean operations functors. More...
- struct logical_not
    One of the Boolean operations functors. More...
- struct logical_or
    One of the Boolean operations functors. More...
- class map
    A standard container made up of (key,value) pairs, which can be retrieved based on a key, in logarithmic time. More...
- class mask_array
    Reference to selected subset of an array. More...
- class mem_fun1_ref_t
    One of the adaptors for member pointers. More...
- class mem_fun1_ref_t< void, _Tp, _Arg >
    One of the adaptors for member pointers. More...
- class mem_fun1_t
    One of the adaptors for member pointers. More...
- class mem_fun1_t< void, _Tp, _Arg >
    One of the adaptors for member pointers. More...
- class mem_fun_ref_t
    One of the adaptors for member pointers. More...
- class mem_fun_ref_t< void, _Tp >
    One of the adaptors for member pointers. More...
- class mem_fun_t
    One of the adaptors for member pointers. More...
- class mem_fun_t< void, _Tp >
    One of the adaptors for member pointers. More...
- class messages
    Facet for handling message catalogs. More...
- struct messages_base
    Messages facet base class providing catalog typedef. More...
- class messages_byname
    class messages_byname [22.2.7.2]. More...
- struct minus
    One of the math functors. More...
- struct modulus
    One of the math functors. More...
- class money_base
    Money format ordering data. More...
- class money_get
    Facet for parsing monetary amounts. More...
- class money_put
    Facet for outputting monetary amounts. More...
- class moneypunct
    Facet for formatting data for money amounts. More...
- class moneypunct_byname
    class moneypunct_byname [22.2.6.4]. More...
- class multimap
    A standard container made up of (key,value) pairs, which can be retrieved based on a key, in logarithmic time. More...
- struct multiplies
    One of the math functors. More...
- class multiset
    A standard container made up of elements, which can be retrieved in logarithmic time. More...
- struct negate
    One of the math functors. More...
- struct not_equal_to
    One of the comparison functors. More...
- class num_get
    Facet for parsing number strings. More...
- class num_put
    Facet for converting numbers to strings. More...
- struct numeric_limits
    Properties of fundamental types. More...
- struct numeric_limits< bool >
    numeric_limits<bool> specialization. More...
- struct numeric_limits< char >
    numeric_limits<char> specialization. More...
- struct numeric_limits< double >
    numeric_limits<double> specialization. More...
- struct numeric_limits< float >
    numeric_limits<float> specialization. More...
- struct numeric_limits< int >
    numeric_limits<int> specialization. More...
- struct numeric_limits< long >
    numeric_limits<long> specialization. More...
- struct numeric_limits< long double >
    numeric_limits<long double> specialization. More...
- struct numeric_limits< long long >
    numeric_limits<long long> specialization. More...
- struct numeric_limits< short >
    numeric_limits<short> specialization. More...
- struct numeric_limits< signed char >
    numeric_limits<signed char> specialization. More...
- struct numeric_limits< unsigned char >
    numeric_limits<unsigned char> specialization. More...
- struct numeric_limits< unsigned int >
    numeric_limits<unsigned int> specialization. More...
- struct numeric_limits< unsigned long >
    numeric_limits<unsigned long> specialization. More...
- struct numeric_limits< unsigned long long >
    numeric_limits<unsigned long long> specialization. More...
- struct numeric_limits< unsigned short >
    numeric_limits<unsigned short> specialization. More...
- struct numeric_limits< wchar_t >
    numeric_limits<wchar_t> specialization. More...
- class numpunct
    Numpunct facet. More...
- class numpunct_byname
    class numpunct_byname [22.2.3.2]. More...
- class ostream_iterator
    Provides output iterator semantics for streams. More...
- class ostreambuf_iterator
    Provides output iterator semantics for streambufs. More...
- class out_of_range
- struct output_iterator_tag
    Marking output iterators. More...
- class overflow_error
- struct pair
    pair holds two objects of arbitrary type. More...
- struct plus
    One of the math functors. More...
- class pointer_to_binary_function
    One of the adaptors for function pointers. More...
- class pointer_to_unary_function
    One of the adaptors for function pointers. More...
- class priority_queue
    A standard container automatically sorting its contents. More...
- class queue
    A standard container giving FIFO behavior. More...
- struct random_access_iterator_tag
    operations. More...
- class range_error
- class raw_storage_iterator
- class reverse_iterator
- class runtime_error
    One of two subclasses of exception. More...
- class set
    A standard container made up of unique keys, which can be retrieved in logarithmic time. More...
- class slice
    Class defining one-dimensional subset of an array. More...
- class slice_array
    Reference to one-dimensional subset of an array. More...
- class stack
    A standard container giving FILO behavior. More...
- class time_base
    Time format ordering data. More...
- class time_get
    Facet for parsing dates and times. More...
- class time_get_byname
    class time_get_byname [22.2.5.2]. More...
- class time_put
    Facet for outputting dates and times. More...
- class time_put_byname
    class time_put_byname [22.2.5.4]. More...
- class type_info
    Part of RTTI. More...
- struct unary_function
- class unary_negate
    One of the negation functors. More...
- class underflow_error
- class valarray
    Smart array designed to support numeric processing. More...
- class vector
    A standard container which offers fixed time access to individual elements in any order. More...
- class vector< bool, _Alloc >
    A specialization of vector for booleans which offers fixed time access to individual elements in any order. More...

## Namespaces

- namespace rel_ops
- namespace tr1

## Standard Stream Objects

The <iostream> header declares the eight standard stream objects. For other declarations, see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#10 and the I/O forward declarations

They are required by default to cooperate with the global C library's `FILE` streams, and to be available during program startup and termination. For more information, see the HOWTO linked to above.

- ostream cerr
- istream cin
- ostream clog
- ostream cout
- wostream wcerr
- wistream wcin
- wostream wclog
- wostream wcout

## Typedefs

- typedef FILE __c_file
- typedef __locale_t __c_locale
- typedef __gthread_mutex_t __c_lock
- typedef unsigned long _Bit_type
- typedef basic_filebuf< char > filebuf
- typedef basic_fstream< char > fstream
- typedef basic_ifstream< char > ifstream
- typedef basic_ios< char > ios
- typedef basic_iostream< char > iostream
- typedef basic_istream< char > istream
- typedef basic_istringstream<
  char > istringstream
- typedef void(* new_handler )()
- typedef basic_ofstream< char > ofstream
- typedef basic_ostream< char > ostream
- typedef basic_ostringstream<
  char > ostringstream
- typedef basic_streambuf< char > streambuf
- typedef long long streamoff
- typedef fpos< mbstate_t > streampos
- typedef ptrdiff_t streamsize
- typedef basic_string< char > string
- typedef basic_stringbuf< char > stringbuf
- typedef basic_stringstream<
  char > stringstream
- typedef void(* terminate_handler )()
- typedef void(* unexpected_handler )()
- typedef basic_filebuf< wchar_t > wfilebuf
- typedef basic_fstream< wchar_t > wfstream
- typedef basic_ifstream< wchar_t > wifstream
- typedef basic_ios< wchar_t > wios
- typedef basic_iostream< wchar_t > wiostream
- typedef basic_istream< wchar_t > wistream
- typedef basic_istringstream<
  wchar_t > wistringstream
- typedef basic_ofstream< wchar_t > wofstream
- typedef basic_ostream< wchar_t > wostream
- typedef basic_ostringstream<
  wchar_t > wostringstream
- typedef basic_streambuf< wchar_t > wstreambuf
- typedef fpos< mbstate_t > wstreampos
- typedef basic_string< wchar_t > wstring
- typedef basic_stringbuf< wchar_t > wstringbuf
- typedef basic_stringstream<
  wchar_t > wstringstream

## Enumerations

- enum { _S_threshold }
- enum { _S_chunk_size }
- enum _Ios_Fmtflags {
  _S_boolalpha, _S_dec, _S_fixed, _S_hex,
  _S_internal, _S_left, _S_oct, _S_right,
  _S_scientific, _S_showbase, _S_showpoint, _S_showpos,
  _S_skipws, _S_unitbuf, _S_uppercase, _S_adjustfield,
  _S_basefield, _S_floatfield, _S_ios_fmtflags_end
  }
- enum _Ios_Iostate {
  _S_goodbit, _S_badbit, _S_eofbit, _S_failbit,
  _S_ios_iostate_end
  }
- enum _Ios_Openmode {
  _S_app, _S_ate, _S_bin, _S_in,
  _S_out, _S_trunc, _S_ios_openmode_end
  }
- enum _Ios_Seekdir { _S_beg, _S_cur, _S_end, _S_ios_seekdir_end }
- enum _Rb_tree_color { _S_red, _S_black }
- enum _S_word_bit_enum { _S_word_bit }
- enum float_denorm_style { denorm_indeterminate, denorm_absent, denorm_present }
- enum float_round_style {
  round_indeterminate, round_toward_zero, round_to_nearest, round_toward_infinity,
  round_toward_neg_infinity
  }

## Functions

- template<typename _CharT> _CharT * __add_grouping (_CharT *__s, _CharT __sep, const char *__gbeg, size_t __gsize, const _CharT *__first, const _CharT *__last)
- template<typename _RandomAccessIterator, typename _Distance, typename _Tp, typename _Compare> void __adjust_heap (_RandomAccessIterator __first, _Distance __holeIndex, _Distance __len, _Tp __value, _Compare __comp)
- template<typename _RandomAccessIterator, typename _Distance, typename _Tp> void __adjust_heap (_RandomAccessIterator __first, _Distance __holeIndex, _Distance __len, _Tp __value)
- template<typename _RandomAccessIterator, typename _Distance> void __advance (_RandomAccessIterator &__i, _Distance __n, random_access_iterator_tag)
- template<typename _BidirectionalIterator, typename _Distance> void __advance (_BidirectionalIterator &__i, _Distance __n, bidirectional_iterator_tag)
- template<typename _InputIterator, typename _Distance> void __advance (_InputIterator &__i, _Distance __n, input_iterator_tag)
- template<typename _Facet> const _Facet & __check_facet (const _Facet *__f)
- template<typename _RandomAccessIterator, typename _Distance, typename _Compare> void __chunk_insertion_sort (_RandomAccessIterator __first, _RandomAccessIterator __last, _Distance __chunk_size, _Compare __comp)
- template<typename _RandomAccessIterator, typename _Distance> void __chunk_insertion_sort (_RandomAccessIterator __first, _RandomAccessIterator __last, _Distance __chunk_size)
- template<typename _Tp> _Tp __cmath_power (_Tp __x, unsigned int __n)
- template<typename _Tv> int __convert_from_v (char *__out, const int __size, const char *__fmt, _Tv __v, const __c_locale &, int __prec)
- template<> void __convert_to_v (const char *, long double &, ios_base::iostate &, const __c_locale &)
- template<> void __convert_to_v (const char *, double &, ios_base::iostate &, const __c_locale &)
- template<> void __convert_to_v (const char *, float &, ios_base::iostate &, const __c_locale &)
- template<typename _Tv> void __convert_to_v (const char *__in, _Tv &__out, ios_base::iostate &__err, const __c_locale &__cloc)
- template<typename _II, typename _OI> _OI __copy_aux (_II __first, _II __last, _OI __result)
- template<typename _BI1, typename _BI2> _BI2 __copy_backward_aux (_BI1 __first, _BI1 __last, _BI2 __result)
- template<> streamsize __copy_streambufs (basic_streambuf< wchar_t > *__sbin, basic_streambuf< wchar_t > *__sbout)
- template<> streamsize __copy_streambufs (basic_streambuf< char > *__sbin, basic_streambuf< char > *__sbout)
- template<typename _CharT, typename _Traits> streamsize __copy_streambufs (basic_streambuf< _CharT, _Traits > *__sbin, basic_streambuf< _CharT, _Traits > *__sbout)
- size_t __deque_buf_size (size_t __size)
- template<typename _ForwardIterator> void __destroy_aux (_ForwardIterator, _ForwardIterator, __true_type)
- template<typename _ForwardIterator> void __destroy_aux (_ForwardIterator __first, _ForwardIterator __last, __false_type)
- template<typename _RandomAccessIterator> iterator_traits< _RandomAccessIterator
  >::difference_type __distance (_RandomAccessIterator __first, _RandomAccessIterator __last, random_access_iterator_tag)
- template<typename _InputIterator> iterator_traits< _InputIterator
  >::difference_type __distance (_InputIterator __first, _InputIterator __last, input_iterator_tag)
- template<typename _RandomAccessIterator, typename _Compare> void __final_insertion_sort (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
- template<typename _RandomAccessIterator> void __final_insertion_sort (_RandomAccessIterator __first, _RandomAccessIterator __last)
- template<typename _BidirectionalIterator1, typename _BidirectionalIterator2, typename _BinaryPredicate> _BidirectionalIterator1 __find_end (_BidirectionalIterator1 __first1, _BidirectionalIterator1 __last1, _BidirectionalIterator2 __first2, _BidirectionalIterator2 __last2, bidirectional_iterator_tag, bidirectional_iterator_tag, _BinaryPredicate __comp)
- template<typename _BidirectionalIterator1, typename _BidirectionalIterator2> _BidirectionalIterator1 __find_end (_BidirectionalIterator1 __first1, _BidirectionalIterator1 __last1, _BidirectionalIterator2 __first2, _BidirectionalIterator2 __last2, bidirectional_iterator_tag, bidirectional_iterator_tag)
- template<typename _ForwardIterator1, typename _ForwardIterator2, typename _BinaryPredicate> _ForwardIterator1 __find_end (_ForwardIterator1 __first1, _ForwardIterator1 __last1, _ForwardIterator2 __first2, _ForwardIterator2 __last2, forward_iterator_tag, forward_iterator_tag, _BinaryPredicate __comp)
- template<typename _ForwardIterator1, typename _ForwardIterator2> _ForwardIterator1 __find_end (_ForwardIterator1 __first1, _ForwardIterator1 __last1, _ForwardIterator2 __first2, _ForwardIterator2 __last2, forward_iterator_tag, forward_iterator_tag)
- template<typename _EuclideanRingElement> _EuclideanRingElement __gcd (_EuclideanRingElement __m, _EuclideanRingElement __n)
- template<typename _Tp> pair< _Tp *, ptrdiff_t > __get_temporary_buffer (ptrdiff_t __len, _Tp *)
- template<typename _T> size_t __iconv_adaptor (size_t(*__func)(iconv_t, _T, size_t *, char **, size_t *), iconv_t __cd, char **__inbuf, size_t *__inbytes, char **__outbuf, size_t *__outbytes)
- template<typename _ForwardIterator, typename _Predicate, typename _Distance> _ForwardIterator __inplace_stable_partition (_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred, _Distance __len)
- template<typename _RandomAccessIterator, typename _Compare> void __inplace_stable_sort (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
- template<typename _RandomAccessIterator> void __inplace_stable_sort (_RandomAccessIterator __first, _RandomAccessIterator __last)
- template<typename _RandomAccessIterator, typename _Compare> void __insertion_sort (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
- template<typename _RandomAccessIterator> void __insertion_sort (_RandomAccessIterator __first, _RandomAccessIterator __last)
- template<typename _CharT, typename _ValueT> int __int_to_char (_CharT *__bufend, _ValueT __v, const _CharT *__lit, ios_base::fmtflags __flags, bool)
- template<typename _CharT> int __int_to_char (_CharT *__bufend, unsigned long long __v, const _CharT *__lit, ios_base::fmtflags __flags)
- template<typename _CharT> int __int_to_char (_CharT *__bufend, long long __v, const _CharT *__lit, ios_base::fmtflags __flags)
- template<typename _CharT> int __int_to_char (_CharT *__bufend, unsigned long __v, const _CharT *__lit, ios_base::fmtflags __flags)
- template<typename _CharT> int __int_to_char (_CharT *__bufend, long __v, const _CharT *__lit, ios_base::fmtflags __flags)
- template<typename _RandomAccessIterator, typename _Size, typename _Compare> void __introsort_loop (_RandomAccessIterator __first, _RandomAccessIterator __last, _Size __depth_limit, _Compare __comp)
- template<typename _RandomAccessIterator, typename _Size> void __introsort_loop (_RandomAccessIterator __first, _RandomAccessIterator __last, _Size __depth_limit)
- template<typename _RandomAccessIterator, typename _StrictWeakOrdering> bool __is_heap (_RandomAccessIterator __first, _RandomAccessIterator __last, _StrictWeakOrdering __comp)
- template<typename _RandomAccessIterator> bool __is_heap (_RandomAccessIterator __first, _RandomAccessIterator __last)
- template<typename _RandomAccessIterator, typename _Distance, typename _StrictWeakOrdering> bool __is_heap (_RandomAccessIterator __first, _StrictWeakOrdering __comp, _Distance __n)
- template<typename _RandomAccessIterator, typename _Distance> bool __is_heap (_RandomAccessIterator __first, _Distance __n)
- template<typename _Type> bool __is_null_pointer (_Type)
- template<typename _Type> bool __is_null_pointer (_Type *__ptr)
- template<typename _Iter> iterator_traits< _Iter
  >::iterator_category __iterator_category (const _Iter &)
- template<typename _Size> _Size __lg (_Size __n)
- template<typename _Tp, typename _Compare> const _Tp & __median (const _Tp &__a, const _Tp &__b, const _Tp &__c, _Compare __comp)
- template<typename _Tp> const _Tp & __median (const _Tp &__a, const _Tp &__b, const _Tp &__c)
- template<typename _BidirectionalIterator, typename _Distance, typename _Pointer, typename _Compare> void __merge_adaptive (_BidirectionalIterator __first, _BidirectionalIterator __middle, _BidirectionalIterator __last, _Distance __len1, _Distance __len2, _Pointer __buffer, _Distance __buffer_size, _Compare __comp)
- template<typename _BidirectionalIterator, typename _Distance, typename _Pointer> void __merge_adaptive (_BidirectionalIterator __first, _BidirectionalIterator __middle, _BidirectionalIterator __last, _Distance __len1, _Distance __len2, _Pointer __buffer, _Distance __buffer_size)
- template<typename _BidirectionalIterator1, typename _BidirectionalIterator2, typename _BidirectionalIterator3, typename _Compare> _BidirectionalIterator3 __merge_backward (_BidirectionalIterator1 __first1, _BidirectionalIterator1 __last1, _BidirectionalIterator2 __first2, _BidirectionalIterator2 __last2, _BidirectionalIterator3 __result, _Compare __comp)
- template<typename _BidirectionalIterator1, typename _BidirectionalIterator2, typename _BidirectionalIterator3> _BidirectionalIterator3 __merge_backward (_BidirectionalIterator1 __first1, _BidirectionalIterator1 __last1, _BidirectionalIterator2 __first2, _BidirectionalIterator2 __last2, _BidirectionalIterator3 __result)
- template<typename _RandomAccessIterator1, typename _RandomAccessIterator2, typename _Distance, typename _Compare> void __merge_sort_loop (_RandomAccessIterator1 __first, _RandomAccessIterator1 __last, _RandomAccessIterator2 __result, _Distance __step_size, _Compare __comp)
- template<typename _RandomAccessIterator1, typename _RandomAccessIterator2, typename _Distance> void __merge_sort_loop (_RandomAccessIterator1 __first, _RandomAccessIterator1 __last, _RandomAccessIterator2 __result, _Distance __step_size)
- template<typename _RandomAccessIterator, typename _Pointer, typename _Compare> void __merge_sort_with_buffer (_RandomAccessIterator __first, _RandomAccessIterator __last, _Pointer __buffer, _Compare __comp)
- template<typename _RandomAccessIterator, typename _Pointer> void __merge_sort_with_buffer (_RandomAccessIterator __first, _RandomAccessIterator __last, _Pointer __buffer)
- template<typename _BidirectionalIterator, typename _Distance, typename _Compare> void __merge_without_buffer (_BidirectionalIterator __first, _BidirectionalIterator __middle, _BidirectionalIterator __last, _Distance __len1, _Distance __len2, _Compare __comp)
- template<typename _BidirectionalIterator, typename _Distance> void __merge_without_buffer (_BidirectionalIterator __first, _BidirectionalIterator __middle, _BidirectionalIterator __last, _Distance __len1, _Distance __len2)
- template<typename _BidirectionalIterator, typename _Predicate> _BidirectionalIterator __partition (_BidirectionalIterator __first, _BidirectionalIterator __last, _Predicate __pred, bidirectional_iterator_tag)
- template<typename _ForwardIterator, typename _Predicate> _ForwardIterator __partition (_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred, forward_iterator_tag)
- template<typename _RandomAccessIterator, typename _Tp, typename _Compare> void __pop_heap (_RandomAccessIterator __first, _RandomAccessIterator __last, _RandomAccessIterator __result, _Tp __value, _Compare __comp)
- template<typename _RandomAccessIterator, typename _Tp> void __pop_heap (_RandomAccessIterator __first, _RandomAccessIterator __last, _RandomAccessIterator __result, _Tp __value)
- template<typename _RandomAccessIterator, typename _Distance, typename _Tp, typename _Compare> void __push_heap (_RandomAccessIterator __first, _Distance __holeIndex, _Distance __topIndex, _Tp __value, _Compare __comp)
- template<typename _RandomAccessIterator, typename _Distance, typename _Tp> void __push_heap (_RandomAccessIterator __first, _Distance __holeIndex, _Distance __topIndex, _Tp __value)
- template<typename _RandomAccessIterator> void __reverse (_RandomAccessIterator __first, _RandomAccessIterator __last, random_access_iterator_tag)
- template<typename _BidirectionalIterator> void __reverse (_BidirectionalIterator __first, _BidirectionalIterator __last, bidirectional_iterator_tag)
- template<typename _RandomAccessIterator> void __rotate (_RandomAccessIterator __first, _RandomAccessIterator __middle, _RandomAccessIterator __last, random_access_iterator_tag)
- template<typename _BidirectionalIterator> void __rotate (_BidirectionalIterator __first, _BidirectionalIterator __middle, _BidirectionalIterator __last, bidirectional_iterator_tag)
- template<typename _ForwardIterator> void __rotate (_ForwardIterator __first, _ForwardIterator __middle, _ForwardIterator __last, forward_iterator_tag)
- template<typename _BidirectionalIterator1, typename _BidirectionalIterator2, typename _Distance> _BidirectionalIterator1 __rotate_adaptive (_BidirectionalIterator1 __first, _BidirectionalIterator1 __middle, _BidirectionalIterator1 __last, _Distance __len1, _Distance __len2, _BidirectionalIterator2 __buffer, _Distance __buffer_size)
- template<typename _ForwardIterator, typename _Pointer, typename _Predicate, typename _Distance> _ForwardIterator __stable_partition_adaptive (_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred, _Distance __len, _Pointer __buffer, _Distance __buffer_size)
- template<typename _RandomAccessIterator, typename _Pointer, typename _Distance, typename _Compare> void __stable_sort_adaptive (_RandomAccessIterator __first, _RandomAccessIterator __last, _Pointer __buffer, _Distance __buffer_size, _Compare __comp)
- template<typename _RandomAccessIterator, typename _Pointer, typename _Distance> void __stable_sort_adaptive (_RandomAccessIterator __first, _RandomAccessIterator __last, _Pointer __buffer, _Distance __buffer_size)
- void __throw_bad_alloc (void) __attribute__((__noreturn__))
- void __throw_bad_cast (void) __attribute__((__noreturn__))
- void __throw_bad_exception (void) __attribute__((__noreturn__))
- void __throw_bad_typeid (void) __attribute__((__noreturn__))
- void __throw_domain_error (const char *__s) __attribute__((__noreturn__))
- void __throw_invalid_argument (const char *__s) __attribute__((__noreturn__))
- void __throw_ios_failure (const char *__s) __attribute__((__noreturn__))
- void __throw_length_error (const char *__s) __attribute__((__noreturn__))
- void __throw_logic_error (const char *__s) __attribute__((__noreturn__))
- void __throw_out_of_range (const char *__s) __attribute__((__noreturn__))
- void __throw_overflow_error (const char *__s) __attribute__((__noreturn__))
- void __throw_range_error (const char *__s) __attribute__((__noreturn__))
- void __throw_runtime_error (const char *__s) __attribute__((__noreturn__))
- void __throw_underflow_error (const char *__s) __attribute__((__noreturn__))
- template<typename _RandomAccessIterator, typename _Compare> void __unguarded_insertion_sort (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
- template<typename _RandomAccessIterator> void __unguarded_insertion_sort (_RandomAccessIterator __first, _RandomAccessIterator __last)
- template<typename _RandomAccessIterator, typename _Tp, typename _Compare> void __unguarded_linear_insert (_RandomAccessIterator __last, _Tp __val, _Compare __comp)
- template<typename _RandomAccessIterator, typename _Tp> void __unguarded_linear_insert (_RandomAccessIterator __last, _Tp __val)
- template<typename _RandomAccessIterator, typename _Tp, typename _Compare> _RandomAccessIterator __unguarded_partition (_RandomAccessIterator __first, _RandomAccessIterator __last, _Tp __pivot, _Compare __comp)
- template<typename _RandomAccessIterator, typename _Tp> _RandomAccessIterator __unguarded_partition (_RandomAccessIterator __first, _RandomAccessIterator __last, _Tp __pivot)
- template<typename _InputIterator, typename _ForwardIterator, typename _Tp> _ForwardIterator __uninitialized_copy_a (_InputIterator __first, _InputIterator __last, _ForwardIterator __result, allocator< _Tp >)
- template<typename _InputIterator, typename _ForwardIterator, typename _Allocator> _ForwardIterator __uninitialized_copy_a (_InputIterator __first, _InputIterator __last, _ForwardIterator __result, _Allocator __alloc)
- template<typename _InputIterator, typename _ForwardIterator> _ForwardIterator __uninitialized_copy_aux (_InputIterator __first, _InputIterator __last, _ForwardIterator __result, __false_type)
- template<typename _InputIterator, typename _ForwardIterator> _ForwardIterator __uninitialized_copy_aux (_InputIterator __first, _InputIterator __last, _ForwardIterator __result, __true_type)
- template<typename _InputIterator1, typename _InputIterator2, typename _ForwardIterator, typename _Allocator> _ForwardIterator __uninitialized_copy_copy (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2, _ForwardIterator __result, _Allocator __alloc)
- template<typename _InputIterator, typename _ForwardIterator, typename _Tp, typename _Allocator> void __uninitialized_copy_fill (_InputIterator __first1, _InputIterator __last1, _ForwardIterator __first2, _ForwardIterator __last2, const _Tp &__x, _Allocator __alloc)
- template<typename _ForwardIterator, typename _Tp, typename _Tp2> void __uninitialized_fill_a (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__x, allocator< _Tp2 >)
- template<typename _ForwardIterator, typename _Tp, typename _Allocator> void __uninitialized_fill_a (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__x, _Allocator __alloc)
- template<typename _ForwardIterator, typename _Tp> void __uninitialized_fill_aux (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__x, __false_type)
- template<typename _ForwardIterator, typename _Tp> void __uninitialized_fill_aux (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__x, __true_type)
- template<typename _ForwardIterator, typename _Tp, typename _InputIterator, typename _Allocator> _ForwardIterator __uninitialized_fill_copy (_ForwardIterator __result, _ForwardIterator __mid, const _Tp &__x, _InputIterator __first, _InputIterator __last, _Allocator __alloc)
- template<typename _ForwardIterator, typename _Size, typename _Tp, typename _Tp2> void __uninitialized_fill_n_a (_ForwardIterator __first, _Size __n, const _Tp &__x, allocator< _Tp2 >)
- template<typename _ForwardIterator, typename _Size, typename _Tp, typename _Allocator> void __uninitialized_fill_n_a (_ForwardIterator __first, _Size __n, const _Tp &__x, _Allocator __alloc)
- template<typename _ForwardIterator, typename _Size, typename _Tp> void __uninitialized_fill_n_aux (_ForwardIterator __first, _Size __n, const _Tp &__x, __false_type)
- template<typename _ForwardIterator, typename _Size, typename _Tp> void __uninitialized_fill_n_aux (_ForwardIterator __first, _Size __n, const _Tp &__x, __true_type)
- template<typename _InputIterator, typename _ForwardIterator, typename _BinaryPredicate> _ForwardIterator __unique_copy (_InputIterator __first, _InputIterator __last, _ForwardIterator __result, _BinaryPredicate __binary_pred, forward_iterator_tag)
- template<typename _InputIterator, typename _OutputIterator, typename _BinaryPredicate> _OutputIterator __unique_copy (_InputIterator __first, _InputIterator __last, _OutputIterator __result, _BinaryPredicate __binary_pred, output_iterator_tag)
- template<typename _InputIterator, typename _ForwardIterator> _ForwardIterator __unique_copy (_InputIterator __first, _InputIterator __last, _ForwardIterator __result, forward_iterator_tag)
- template<typename _InputIterator, typename _OutputIterator> _OutputIterator __unique_copy (_InputIterator __first, _InputIterator __last, _OutputIterator __result, output_iterator_tag)
- template<typename _Tp, class _Dom> void __valarray_copy (const _Expr< _Dom, _Tp > &__e, size_t __n, _Array< _Tp > __a, _Array< bool > __m)
- template<typename _Tp> void __valarray_copy (_Array< _Tp > __e, _Array< size_t > __f, size_t __n, _Array< _Tp > __a, _Array< size_t > __i)
- template<typename _Tp, class _Dom> void __valarray_copy (const _Expr< _Dom, _Tp > &__e, size_t __n, _Array< _Tp > __a, _Array< size_t > __i)
- template<typename _Tp, class _Dom> void __valarray_copy (const _Expr< _Dom, _Tp > &__e, size_t __n, _Array< _Tp > __a, size_t __s)
- template<typename _Tp, class _Dom> void __valarray_copy (const _Expr< _Dom, _Tp > &__e, size_t __n, _Array< _Tp > __a)
- template<typename _Tp> void __valarray_copy (_Array< _Tp > __a, _Array< bool > __m, size_t __n, _Array< _Tp > __b, _Array< bool > __k)
- template<typename _Tp> void __valarray_copy (_Array< _Tp > __a, size_t __n, _Array< _Tp > __b, _Array< bool > __m)
- template<typename _Tp> void __valarray_copy (_Array< _Tp > __a, _Array< bool > __m, _Array< _Tp > __b, size_t __n)
- template<typename _Tp> void __valarray_copy (_Array< _Tp > __src, size_t __n, _Array< size_t > __i, _Array< _Tp > __dst, _Array< size_t > __j)
- template<typename _Tp> void __valarray_copy (_Array< _Tp > __a, size_t __n, _Array< _Tp > __b, _Array< size_t > __i)
- template<typename _Tp> void __valarray_copy (_Array< _Tp > __a, _Array< size_t > __i, _Array< _Tp > __b, size_t __n)
- template<typename _Tp> void __valarray_copy (_Array< _Tp > __a, size_t __n, size_t __s1, _Array< _Tp > __b, size_t __s2)
- template<typename _Tp> void __valarray_copy (_Array< _Tp > __a, _Array< _Tp > __b, size_t __n, size_t __s)
- template<typename _Tp> void __valarray_copy (_Array< _Tp > __a, size_t __n, size_t __s, _Array< _Tp > __b)
- template<typename _Tp> void __valarray_copy (_Array< _Tp > __a, size_t __n, _Array< _Tp > __b)
- template<typename _Tp> void __valarray_copy (const _Tp *__restrict__ __src, size_t __n, const size_t *__restrict__ __i, _Tp *__restrict__ __dst, const size_t *__restrict__ __j)
- template<typename _Tp> void __valarray_copy (const _Tp *__restrict__ __a, size_t __n, _Tp *__restrict__ __b, const size_t *__restrict__ __i)
- template<typename _Tp> void __valarray_copy (const _Tp *__restrict__ __a, const size_t *__restrict__ __i, _Tp *__restrict__ __b, size_t __n)
- template<typename _Tp> void __valarray_copy (const _Tp *__restrict__ __src, size_t __n, size_t __s1, _Tp *__restrict__ __dst, size_t __s2)
- template<typename _Tp> void __valarray_copy (const _Tp *__restrict__ __a, _Tp *__restrict__ __b, size_t __n, size_t __s)
- template<typename _Tp> void __valarray_copy (const _Tp *__restrict__ __a, size_t __n, size_t __s, _Tp *__restrict__ __b)
- template<typename _Tp> void __valarray_copy (const _Tp *__restrict__ __a, size_t __n, _Tp *__restrict__ __b)
- template<typename _Tp> void __valarray_copy_construct (_Array< _Tp > __a, _Array< bool > __m, _Array< _Tp > __b, size_t __n)
- template<typename _Tp, class _Dom> void __valarray_copy_construct (const _Expr< _Dom, _Tp > &__e, size_t __n, _Array< _Tp > __a)
- template<typename _Tp> void __valarray_copy_construct (const _Tp *__restrict__ __a, const size_t *__restrict__ __i, _Tp *__restrict__ __o, size_t __n)
- template<typename _Tp> void __valarray_copy_construct (const _Tp *__restrict__ __a, size_t __n, size_t __s, _Tp *__restrict__ __o)
- template<typename _Tp> void __valarray_copy_construct (const _Tp *__restrict__ __b, const _Tp *__restrict__ __e, _Tp *__restrict__ __o)
- template<typename _Tp> void __valarray_default_construct (_Tp *__restrict__ __b, _Tp *__restrict__ __e)
- template<typename _Tp> void __valarray_destroy_elements (_Tp *__restrict__ __b, _Tp *__restrict__ __e)
- template<typename _Tp> void __valarray_fill (_Array< _Tp > __a, size_t __n, _Array< bool > __m, const _Tp &__t)
- template<typename _Tp> void __valarray_fill (_Array< _Tp > __a, _Array< size_t > __i, size_t __n, const _Tp &__t)
- template<typename _Tp> void __valarray_fill (_Array< _Tp > __a, size_t __n, size_t __s, const _Tp &__t)
- template<typename _Tp> void __valarray_fill (_Array< _Tp > __a, size_t __n, const _Tp &__t)
- template<typename _Tp> void __valarray_fill (_Tp *__restrict__ __a, const size_t *__restrict__ __i, size_t __n, const _Tp &__t)
- template<typename _Tp> void __valarray_fill (_Tp *__restrict__ __a, size_t __n, size_t __s, const _Tp &__t)
- template<typename _Tp> void __valarray_fill (_Tp *__restrict__ __a, size_t __n, const _Tp &__t)
- template<typename _Tp> void __valarray_fill_construct (_Tp *__restrict__ __b, _Tp *__restrict__ __e, const _Tp __t)
- void * __valarray_get_memory (size_t __n)
- template<typename _Tp> _Tp *__restrict__ __valarray_get_storage (size_t __n)
- template<typename _Ta> _Ta::value_type __valarray_max (const _Ta &__a)
- template<typename _Ta> _Ta::value_type __valarray_min (const _Ta &__a)
- template<typename _Tp> _Tp __valarray_product (const _Tp *__restrict__ __f, const _Tp *__restrict__ __l)
- void __valarray_release_memory (void *__p)
- template<typename _Tp> _Tp __valarray_sum (const _Tp *__restrict__ __f, const _Tp *__restrict__ __l)
- static bool __verify_grouping (const char *__grouping, size_t __grouping_size, const string &__grouping_tmp)
- template<typename _CharT, typename _OutIter> _OutIter __write (_OutIter __s, const _CharT *__ws, int __len)
- template<typename _CharT> ostreambuf_iterator< _CharT > __write (ostreambuf_iterator< _CharT > __s, const _CharT *__ws, int __len)
- template<typename _T1> void _Construct (_T1 *__p)
- template<typename _T1, typename _T2> void _Construct (_T1 *__p, const _T2 &__value)
- template<typename _ForwardIterator, typename _Allocator, typename _Tp> void _Destroy (_ForwardIterator __first, _ForwardIterator __last, allocator< _Tp >)
- template<typename _ForwardIterator, typename _Allocator> void _Destroy (_ForwardIterator __first, _ForwardIterator __last, _Allocator __alloc)
- template<typename _ForwardIterator> void _Destroy (_ForwardIterator __first, _ForwardIterator __last)
- template<typename _Tp> void _Destroy (_Tp *__pointer)
- unsigned int _Rb_tree_black_count (const _Rb_tree_node_base *__node, const _Rb_tree_node_base *__root)
- const _Rb_tree_node_base * _Rb_tree_decrement (const _Rb_tree_node_base *__x)
- _Rb_tree_node_base * _Rb_tree_decrement (_Rb_tree_node_base *__x)
- const _Rb_tree_node_base * _Rb_tree_increment (const _Rb_tree_node_base *__x)
- _Rb_tree_node_base * _Rb_tree_increment (_Rb_tree_node_base *__x)
- void _Rb_tree_insert_and_rebalance (const bool __insert_left, _Rb_tree_node_base *__x, _Rb_tree_node_base *__p, _Rb_tree_node_base &__header)
- _Rb_tree_node_base * _Rb_tree_rebalance_for_erase (_Rb_tree_node_base *const __z, _Rb_tree_node_base &__header)
- void _Rb_tree_rotate_left (_Rb_tree_node_base *const __x, _Rb_tree_node_base *&__root)
- void _Rb_tree_rotate_right (_Rb_tree_node_base *const __x, _Rb_tree_node_base *&__root)
- template<typename _InputIterator, typename _Tp, typename _BinaryOperation> _Tp accumulate (_InputIterator __first, _InputIterator __last, _Tp __init, _BinaryOperation __binary_op)
- template<typename _InputIterator, typename _Tp> _Tp accumulate (_InputIterator __first, _InputIterator __last, _Tp __init)
- template<typename _InputIterator, typename _OutputIterator, typename _BinaryOperation> _OutputIterator adjacent_difference (_InputIterator __first, _InputIterator __last, _OutputIterator __result, _BinaryOperation __binary_op)
- template<typename _InputIterator, typename _OutputIterator> _OutputIterator adjacent_difference (_InputIterator __first, _InputIterator __last, _OutputIterator __result)
- template<typename _ForwardIterator, typename _BinaryPredicate> _ForwardIterator adjacent_find (_ForwardIterator __first, _ForwardIterator __last, _BinaryPredicate __binary_pred)
- template<typename _ForwardIterator> _ForwardIterator adjacent_find (_ForwardIterator __first, _ForwardIterator __last)
- template<typename _InputIterator, typename _Distance> void advance (_InputIterator &__i, _Distance __n)
- template<typename _Container> back_insert_iterator< _Container > back_inserter (_Container &__x)
- template<typename _ForwardIterator, typename _Tp, typename _Compare> bool binary_search (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__val, _Compare __comp)
- template<typename _ForwardIterator, typename _Tp> bool binary_search (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__val)
- template<class _Operation, class _Tp> binder1st< _Operation > bind1st (const _Operation &__fn, const _Tp &__x)
- template<class _Operation, class _Tp> binder2nd< _Operation > bind2nd (const _Operation &__fn, const _Tp &__x)
- ios_base & boolalpha (ios_base &__base)
- template<typename _InputIterator, typename _OutputIterator> _OutputIterator copy (_InputIterator __first, _InputIterator __last, _OutputIterator __result)
- template<typename _BI1, typename _BI2> _BI2 copy_backward (_BI1 __first, _BI1 __last, _BI2 __result)
- template<typename _InputIterator, typename _Tp> iterator_traits< _InputIterator
  >::difference_type count (_InputIterator __first, _InputIterator __last, const _Tp &__value)
- template<typename _InputIterator, typename _Predicate> iterator_traits< _InputIterator
  >::difference_type count_if (_InputIterator __first, _InputIterator __last, _Predicate __pred)
- ios_base & dec (ios_base &__base)
- template<typename _InputIterator> iterator_traits< _InputIterator
  >::difference_type distance (_InputIterator __first, _InputIterator __last)
- template<typename _CharT, typename _Traits> basic_ostream< _CharT, _Traits > & endl (basic_ostream< _CharT, _Traits > &__os)
- template<typename _CharT, typename _Traits> basic_ostream< _CharT, _Traits > & ends (basic_ostream< _CharT, _Traits > &__os)
- template<typename _InputIterator1, typename _InputIterator2, typename _BinaryPredicate> bool equal (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _BinaryPredicate __binary_pred)
- template<typename _InputIterator1, typename _InputIterator2> bool equal (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2)
- template<typename _ForwardIterator, typename _Tp, typename _Compare> pair< _ForwardIterator, _ForwardIterator > equal_range (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__val, _Compare __comp)
- template<typename _ForwardIterator, typename _Tp> pair< _ForwardIterator, _ForwardIterator > equal_range (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__val)
- void fill (char *__first, char *__last, const char &__c)
- void fill (signed char *__first, signed char *__last, const signed char &__c)
- void fill (unsigned char *__first, unsigned char *__last, const unsigned char &__c)
- template<typename _ForwardIterator, typename _Tp> void fill (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__value)
- template<typename _Size> char * fill_n (char *__first, _Size __n, const char &__c)
- template<typename _Size> signed char * fill_n (char *__first, _Size __n, const signed char &__c)
- template<typename _Size> unsigned char * fill_n (unsigned char *__first, _Size __n, const unsigned char &__c)
- template<typename _OutputIterator, typename _Size, typename _Tp> _OutputIterator fill_n (_OutputIterator __first, _Size __n, const _Tp &__value)
- template<typename _InputIterator, typename _Tp> _InputIterator find (_InputIterator __first, _InputIterator __last, const _Tp &__val)
- template<typename _RandomAccessIterator, typename _Tp> _RandomAccessIterator find (_RandomAccessIterator __first, _RandomAccessIterator __last, const _Tp &__val, random_access_iterator_tag)
- template<typename _InputIterator, typename _Tp> _InputIterator find (_InputIterator __first, _InputIterator __last, const _Tp &__val, input_iterator_tag)
- template<typename _ForwardIterator1, typename _ForwardIterator2, typename _BinaryPredicate> _ForwardIterator1 find_end (_ForwardIterator1 __first1, _ForwardIterator1 __last1, _ForwardIterator2 __first2, _ForwardIterator2 __last2, _BinaryPredicate __comp)
- template<typename _ForwardIterator1, typename _ForwardIterator2> _ForwardIterator1 find_end (_ForwardIterator1 __first1, _ForwardIterator1 __last1, _ForwardIterator2 __first2, _ForwardIterator2 __last2)
- template<typename _InputIterator, typename _ForwardIterator, typename _BinaryPredicate> _InputIterator find_first_of (_InputIterator __first1, _InputIterator __last1, _ForwardIterator __first2, _ForwardIterator __last2, _BinaryPredicate __comp)
- template<typename _InputIterator, typename _ForwardIterator> _InputIterator find_first_of (_InputIterator __first1, _InputIterator __last1, _ForwardIterator __first2, _ForwardIterator __last2)
- template<typename _InputIterator, typename _Predicate> _InputIterator find_if (_InputIterator __first, _InputIterator __last, _Predicate __pred)
- template<typename _RandomAccessIterator, typename _Predicate> _RandomAccessIterator find_if (_RandomAccessIterator __first, _RandomAccessIterator __last, _Predicate __pred, random_access_iterator_tag)
- template<typename _InputIterator, typename _Predicate> _InputIterator find_if (_InputIterator __first, _InputIterator __last, _Predicate __pred, input_iterator_tag)
- ios_base & fixed (ios_base &__base)
- template<typename _CharT, typename _Traits> basic_ostream< _CharT, _Traits > & flush (basic_ostream< _CharT, _Traits > &__os)
- template<typename _InputIterator, typename _Function> _Function for_each (_InputIterator __first, _InputIterator __last, _Function __f)
- template<typename _Container> front_insert_iterator< _Container > front_inserter (_Container &__x)
- template<typename _ForwardIterator, typename _Generator> void generate (_ForwardIterator __first, _ForwardIterator __last, _Generator __gen)
- template<typename _OutputIterator, typename _Size, typename _Generator> _OutputIterator generate_n (_OutputIterator __first, _Size __n, _Generator __gen)
- template<typename _Tp> pair< _Tp *, ptrdiff_t > get_temporary_buffer (ptrdiff_t __len)
- template<> basic_istream< wchar_t > & getline (basic_istream< wchar_t > &__in, basic_string< wchar_t > &__str, wchar_t __delim)
- template<> basic_istream< char > & getline (basic_istream< char > &__in, basic_string< char > &__str, char __delim)
- template<typename _CharT, typename _Traits, typename _Alloc> basic_istream< _CharT, _Traits > & getline (basic_istream< _CharT, _Traits > &__is, basic_string< _CharT, _Traits, _Alloc > &__str)
- template<typename _CharT, typename _Traits, typename _Alloc> basic_istream< _CharT, _Traits > & getline (basic_istream< _CharT, _Traits > &__is, basic_string< _CharT, _Traits, _Alloc > &__str, _CharT __delim)
- template<typename _Facet> bool has_facet (const locale &__loc) throw ()
- ios_base & hex (ios_base &__base)
- template<typename _InputIterator1, typename _InputIterator2, typename _Compare> bool includes (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2, _Compare __comp)
- template<typename _InputIterator1, typename _InputIterator2> bool includes (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2)
- template<typename _InputIterator1, typename _InputIterator2, typename _Tp, typename _BinaryOperation1, typename _BinaryOperation2> _Tp inner_product (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _Tp __init, _BinaryOperation1 __binary_op1, _BinaryOperation2 __binary_op2)
- template<typename _InputIterator1, typename _InputIterator2, typename _Tp> _Tp inner_product (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _Tp __init)
- template<typename _BidirectionalIterator, typename _Compare> void inplace_merge (_BidirectionalIterator __first, _BidirectionalIterator __middle, _BidirectionalIterator __last, _Compare __comp)
- template<typename _BidirectionalIterator> void inplace_merge (_BidirectionalIterator __first, _BidirectionalIterator __middle, _BidirectionalIterator __last)
- template<typename _Container, typename _Iterator> insert_iterator< _Container > inserter (_Container &__x, _Iterator __i)
- ios_base & internal (ios_base &__base)
- template<typename _CharT> bool isalnum (_CharT __c, const locale &__loc)
- template<typename _CharT> bool isalpha (_CharT __c, const locale &__loc)
- template<typename _CharT> bool iscntrl (_CharT __c, const locale &__loc)
- template<typename _CharT> bool isdigit (_CharT __c, const locale &__loc)
- template<typename _CharT> bool isgraph (_CharT __c, const locale &__loc)
- template<typename _CharT> bool islower (_CharT __c, const locale &__loc)
- template<typename _CharT> bool isprint (_CharT __c, const locale &__loc)
- template<typename _CharT> bool ispunct (_CharT __c, const locale &__loc)
- template<typename _CharT> bool isspace (_CharT __c, const locale &__loc)
- template<typename _CharT> bool isupper (_CharT __c, const locale &__loc)
- template<typename _CharT> bool isxdigit (_CharT __c, const locale &__loc)
- template<typename _ForwardIterator1, typename _ForwardIterator2> void iter_swap (_ForwardIterator1 __a, _ForwardIterator2 __b)
- ios_base & left (ios_base &__base)
- bool lexicographical_compare (const char *__first1, const char *__last1, const char *__first2, const char *__last2)
- bool lexicographical_compare (const unsigned char *__first1, const unsigned char *__last1, const unsigned char *__first2, const unsigned char *__last2)
- template<typename _InputIterator1, typename _InputIterator2, typename _Compare> bool lexicographical_compare (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2, _Compare __comp)
- template<typename _InputIterator1, typename _InputIterator2> bool lexicographical_compare (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2)
- template<typename _ForwardIterator, typename _Tp, typename _Compare> _ForwardIterator lower_bound (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__val, _Compare __comp)
- template<typename _ForwardIterator, typename _Tp> _ForwardIterator lower_bound (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__val)
- template<typename _RandomAccessIterator, typename _Compare> void make_heap (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
- template<typename _RandomAccessIterator> void make_heap (_RandomAccessIterator __first, _RandomAccessIterator __last)
- template<class _T1, class _T2> pair< _T1, _T2 > make_pair (_T1 __x, _T2 __y)
- template<typename _Tp, typename _Compare> const _Tp & max (const _Tp &__a, const _Tp &__b, _Compare __comp)
- template<typename _Tp> const _Tp & max (const _Tp &__a, const _Tp &__b)
- template<typename _ForwardIterator, typename _Compare> _ForwardIterator max_element (_ForwardIterator __first, _ForwardIterator __last, _Compare __comp)
- template<typename _ForwardIterator> _ForwardIterator max_element (_ForwardIterator __first, _ForwardIterator __last)
- template<class _Ret, class _Tp, class _Arg> mem_fun1_t< _Ret, _Tp, _Arg > mem_fun (_Ret(_Tp::*__f)(_Arg))
- template<class _Ret, class _Tp> mem_fun_t< _Ret, _Tp > mem_fun (_Ret(_Tp::*__f)())
- template<class _Ret, class _Tp, class _Arg> mem_fun1_ref_t< _Ret, _Tp,
  _Arg > mem_fun_ref (_Ret(_Tp::*__f)(_Arg))
- template<class _Ret, class _Tp> mem_fun_ref_t< _Ret, _Tp > mem_fun_ref (_Ret(_Tp::*__f)())
- template<typename _InputIterator1, typename _InputIterator2, typename _OutputIterator, typename _Compare> _OutputIterator merge (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)
- template<typename _InputIterator1, typename _InputIterator2, typename _OutputIterator> _OutputIterator merge (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result)
- template<typename _Tp, typename _Compare> const _Tp & min (const _Tp &__a, const _Tp &__b, _Compare __comp)
- template<typename _Tp> const _Tp & min (const _Tp &__a, const _Tp &__b)
- template<typename _ForwardIterator, typename _Compare> _ForwardIterator min_element (_ForwardIterator __first, _ForwardIterator __last, _Compare __comp)
- template<typename _ForwardIterator> _ForwardIterator min_element (_ForwardIterator __first, _ForwardIterator __last)
- template<typename _InputIterator1, typename _InputIterator2, typename _BinaryPredicate> pair< _InputIterator1, _InputIterator2 > mismatch (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _BinaryPredicate __binary_pred)
- template<typename _InputIterator1, typename _InputIterator2> pair< _InputIterator1, _InputIterator2 > mismatch (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2)
- template<typename _BidirectionalIterator, typename _Compare> bool next_permutation (_BidirectionalIterator __first, _BidirectionalIterator __last, _Compare __comp)
- template<typename _BidirectionalIterator> bool next_permutation (_BidirectionalIterator __first, _BidirectionalIterator __last)
- ios_base & noboolalpha (ios_base &__base)
- ios_base & noshowbase (ios_base &__base)
- ios_base & noshowpoint (ios_base &__base)
- ios_base & noshowpos (ios_base &__base)
- ios_base & noskipws (ios_base &__base)
- template<class _Predicate> unary_negate< _Predicate > not1 (const _Predicate &__pred)
- template<class _Predicate> binary_negate< _Predicate > not2 (const _Predicate &__pred)
- ios_base & nounitbuf (ios_base &__base)
- ios_base & nouppercase (ios_base &__base)
- template<typename _RandomAccessIterator, typename _Compare> void nth_element (_RandomAccessIterator __first, _RandomAccessIterator __nth, _RandomAccessIterator __last, _Compare __comp)
- template<typename _RandomAccessIterator> void nth_element (_RandomAccessIterator __first, _RandomAccessIterator __nth, _RandomAccessIterator __last)
- ios_base & oct (ios_base &__base)
- template<size_t _Nb> bitset< _Nb > operator & (const bitset< _Nb > &__x, const bitset< _Nb > &__y)
- _Ios_Iostate operator & (_Ios_Iostate __a, _Ios_Iostate __b)
- _Ios_Openmode operator & (_Ios_Openmode __a, _Ios_Openmode __b)
- _Ios_Fmtflags operator & (_Ios_Fmtflags __a, _Ios_Fmtflags __b)
- _Ios_Iostate & operator &= (_Ios_Iostate &__a, _Ios_Iostate __b)
- _Ios_Openmode & operator &= (_Ios_Openmode &__a, _Ios_Openmode __b)
- _Ios_Fmtflags & operator &= (_Ios_Fmtflags &__a, _Ios_Fmtflags __b)
- template<typename _CharT, typename _Traits> bool operator!= (const istreambuf_iterator< _CharT, _Traits > &__a, const istreambuf_iterator< _CharT, _Traits > &__b)
- template<class _Tp, class _CharT, class _Traits, class _Dist> bool operator!= (const istream_iterator< _Tp, _CharT, _Traits, _Dist > &__x, const istream_iterator< _Tp, _CharT, _Traits, _Dist > &__y)
- template<typename _Tp, typename _Alloc> bool operator!= (const vector< _Tp, _Alloc > &__x, const vector< _Tp, _Alloc > &__y)
- template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc> bool operator!= (const _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > &__x, const _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > &__y)
- template<typename _Val> bool operator!= (const _Rb_tree_iterator< _Val > &__x, const _Rb_tree_const_iterator< _Val > &__y)
- template<typename _Tp, typename _Seq> bool operator!= (const stack< _Tp, _Seq > &__x, const stack< _Tp, _Seq > &__y)
- template<class _Key, class _Compare, class _Alloc> bool operator!= (const set< _Key, _Compare, _Alloc > &__x, const set< _Key, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Sequence> bool operator!= (const queue< _Tp, _Sequence > &__x, const queue< _Tp, _Sequence > &__y)
- template<class _T1, class _T2> bool operator!= (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
- template<class _Key, class _Compare, class _Alloc> bool operator!= (const multiset< _Key, _Compare, _Alloc > &__x, const multiset< _Key, _Compare, _Alloc > &__y)
- template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> bool operator!= (const multimap< _Key, _Tp, _Compare, _Alloc > &__x, const multimap< _Key, _Tp, _Compare, _Alloc > &__y)
- template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> bool operator!= (const map< _Key, _Tp, _Compare, _Alloc > &__x, const map< _Key, _Tp, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Alloc> bool operator!= (const list< _Tp, _Alloc > &__x, const list< _Tp, _Alloc > &__y)
- template<typename _Val> bool operator!= (const _List_iterator< _Val > &__x, const _List_const_iterator< _Val > &__y)
- template<typename _Iterator> bool operator!= (const reverse_iterator< _Iterator > &__x, const reverse_iterator< _Iterator > &__y)
- template<typename _Tp, typename _Alloc> bool operator!= (const deque< _Tp, _Alloc > &__x, const deque< _Tp, _Alloc > &__y)
- template<typename _Tp, typename _RefL, typename _PtrL, typename _RefR, typename _PtrR> bool operator!= (const _Deque_iterator< _Tp, _RefL, _PtrL > &__x, const _Deque_iterator< _Tp, _RefR, _PtrR > &__y)
- template<typename _Tp, typename _Ref, typename _Ptr> bool operator!= (const _Deque_iterator< _Tp, _Ref, _Ptr > &__x, const _Deque_iterator< _Tp, _Ref, _Ptr > &__y)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator!= (const basic_string< _CharT, _Traits, _Alloc > &__lhs, const _CharT *__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator!= (const _CharT *__lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator!= (const basic_string< _CharT, _Traits, _Alloc > &__lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<typename _T1, typename _T2> bool operator!= (const allocator< _T1 > &, const allocator< _T2 > &)
- template<typename _Iterator> reverse_iterator< _Iterator > operator+ (typename reverse_iterator< _Iterator >::difference_type __n, const reverse_iterator< _Iterator > &__x)
- template<typename _Tp, typename _Ref, typename _Ptr> _Deque_iterator< _Tp, _Ref,
  _Ptr > operator+ (ptrdiff_t __n, const _Deque_iterator< _Tp, _Ref, _Ptr > &__x)
- _Bit_const_iterator operator+ (ptrdiff_t __n, const _Bit_const_iterator &__x)
- _Bit_iterator operator+ (ptrdiff_t __n, const _Bit_iterator &__x)
- template<typename _CharT, typename _Traits, typename _Alloc> basic_string< _CharT, _Traits,
  _Alloc > operator+ (const basic_string< _CharT, _Traits, _Alloc > &__lhs, _CharT __rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> basic_string< _CharT, _Traits,
  _Alloc > operator+ (const basic_string< _CharT, _Traits, _Alloc > &__lhs, const _CharT *__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> basic_string< _CharT, _Traits,
  _Alloc > operator+ (_CharT __lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> basic_string< _CharT, _Traits,
  _Alloc > operator+ (const _CharT *__lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> basic_string< _CharT, _Traits,
  _Alloc > operator+ (const basic_string< _CharT, _Traits, _Alloc > &__lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<typename _Iterator> reverse_iterator< _Iterator
  >::difference_type operator- (const reverse_iterator< _Iterator > &__x, const reverse_iterator< _Iterator > &__y)
- template<typename _Tp, typename _RefL, typename _PtrL, typename _RefR, typename _PtrR> _Deque_iterator< _Tp, _RefL,
  _PtrL >::difference_type operator- (const _Deque_iterator< _Tp, _RefL, _PtrL > &__x, const _Deque_iterator< _Tp, _RefR, _PtrR > &__y)
- ptrdiff_t operator- (const _Bit_iterator_base &__x, const _Bit_iterator_base &__y)
- template<typename _Tp, typename _Alloc> bool operator< (const vector< _Tp, _Alloc > &__x, const vector< _Tp, _Alloc > &__y)
- template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc> bool operator< (const _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > &__x, const _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Seq> bool operator< (const stack< _Tp, _Seq > &__x, const stack< _Tp, _Seq > &__y)
- template<class _Key, class _Compare, class _Alloc> bool operator< (const set< _Key, _Compare, _Alloc > &__x, const set< _Key, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Sequence> bool operator< (const queue< _Tp, _Sequence > &__x, const queue< _Tp, _Sequence > &__y)
- template<typename _Tp, typename _Seq> bool operator< (const queue< _Tp, _Seq > &, const queue< _Tp, _Seq > &)
- template<class _T1, class _T2> bool operator< (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
- template<class _Key, class _Compare, class _Alloc> bool operator< (const multiset< _Key, _Compare, _Alloc > &__x, const multiset< _Key, _Compare, _Alloc > &__y)
- template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> bool operator< (const multimap< _Key, _Tp, _Compare, _Alloc > &__x, const multimap< _Key, _Tp, _Compare, _Alloc > &__y)
- template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> bool operator< (const map< _Key, _Tp, _Compare, _Alloc > &__x, const map< _Key, _Tp, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Alloc> bool operator< (const list< _Tp, _Alloc > &__x, const list< _Tp, _Alloc > &__y)
- template<typename _Iterator> bool operator< (const reverse_iterator< _Iterator > &__x, const reverse_iterator< _Iterator > &__y)
- template<typename _Tp, typename _Alloc> bool operator< (const deque< _Tp, _Alloc > &__x, const deque< _Tp, _Alloc > &__y)
- template<typename _Tp, typename _RefL, typename _PtrL, typename _RefR, typename _PtrR> bool operator< (const _Deque_iterator< _Tp, _RefL, _PtrL > &__x, const _Deque_iterator< _Tp, _RefR, _PtrR > &__y)
- template<typename _Tp, typename _Ref, typename _Ptr> bool operator< (const _Deque_iterator< _Tp, _Ref, _Ptr > &__x, const _Deque_iterator< _Tp, _Ref, _Ptr > &__y)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator< (const _CharT *__lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator< (const basic_string< _CharT, _Traits, _Alloc > &__lhs, const _CharT *__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator< (const basic_string< _CharT, _Traits, _Alloc > &__lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<class _Traits> basic_ostream< char, _Traits > & operator<< (basic_ostream< char, _Traits > &__out, const unsigned char *__s)
- template<class _Traits> basic_ostream< char, _Traits > & operator<< (basic_ostream< char, _Traits > &__out, const signed char *__s)
- template<class _Traits> basic_ostream< char, _Traits > & operator<< (basic_ostream< char, _Traits > &__out, unsigned char __c)
- template<class _Traits> basic_ostream< char, _Traits > & operator<< (basic_ostream< char, _Traits > &__out, signed char __c)
- template<typename _CharT, typename _Traits> basic_ostream< _CharT, _Traits > & operator<< (basic_ostream< _CharT, _Traits > &__out, char __c)
- template<typename _CharT, typename _Traits> basic_ostream< _CharT, _Traits > & operator<< (basic_ostream< _CharT, _Traits > &__os, _Setw __f)
- template<typename _CharT, typename _Traits> basic_ostream< _CharT, _Traits > & operator<< (basic_ostream< _CharT, _Traits > &__os, _Setprecision __f)
- template<typename _CharT, typename _Traits> basic_ostream< _CharT, _Traits > & operator<< (basic_ostream< _CharT, _Traits > &__os, _Setfill< _CharT > __f)
- template<typename _CharT, typename _Traits> basic_ostream< _CharT, _Traits > & operator<< (basic_ostream< _CharT, _Traits > &__os, _Setbase __f)
- template<typename _CharT, typename _Traits> basic_ostream< _CharT, _Traits > & operator<< (basic_ostream< _CharT, _Traits > &__os, _Setiosflags __f)
- template<typename _CharT, typename _Traits> basic_ostream< _CharT, _Traits > & operator<< (basic_ostream< _CharT, _Traits > &__os, _Resetiosflags __f)
- template<class _CharT, class _Traits, size_t _Nb> basic_ostream< _CharT, _Traits > & operator<< (basic_ostream< _CharT, _Traits > &__os, const bitset< _Nb > &__x)
- template<class _Traits> basic_ostream< char, _Traits > & operator<< (basic_ostream< char, _Traits > &__out, const char *__s)
- template<typename _CharT, typename _Traits> basic_ostream< _CharT, _Traits > & operator<< (basic_ostream< _CharT, _Traits > &__out, const char *__s)
- template<typename _CharT, typename _Traits> basic_ostream< _CharT, _Traits > & operator<< (basic_ostream< _CharT, _Traits > &__out, const _CharT *__s)
- template<class _Traits> basic_ostream< char, _Traits > & operator<< (basic_ostream< char, _Traits > &__out, char __c)
- template<typename _CharT, typename _Traits> basic_ostream< _CharT, _Traits > & operator<< (basic_ostream< _CharT, _Traits > &__out, _CharT __c)
- template<typename _CharT, typename _Traits, typename _Alloc> basic_ostream< _CharT, _Traits > & operator<< (basic_ostream< _CharT, _Traits > &__os, const basic_string< _CharT, _Traits, _Alloc > &__str)
- template<typename _Tp, typename _Alloc> bool operator<= (const vector< _Tp, _Alloc > &__x, const vector< _Tp, _Alloc > &__y)
- template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc> bool operator<= (const _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > &__x, const _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Seq> bool operator<= (const stack< _Tp, _Seq > &__x, const stack< _Tp, _Seq > &__y)
- template<class _Key, class _Compare, class _Alloc> bool operator<= (const set< _Key, _Compare, _Alloc > &__x, const set< _Key, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Sequence> bool operator<= (const queue< _Tp, _Sequence > &__x, const queue< _Tp, _Sequence > &__y)
- template<class _T1, class _T2> bool operator<= (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
- template<class _Key, class _Compare, class _Alloc> bool operator<= (const multiset< _Key, _Compare, _Alloc > &__x, const multiset< _Key, _Compare, _Alloc > &__y)
- template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> bool operator<= (const multimap< _Key, _Tp, _Compare, _Alloc > &__x, const multimap< _Key, _Tp, _Compare, _Alloc > &__y)
- template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> bool operator<= (const map< _Key, _Tp, _Compare, _Alloc > &__x, const map< _Key, _Tp, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Alloc> bool operator<= (const list< _Tp, _Alloc > &__x, const list< _Tp, _Alloc > &__y)
- template<typename _Iterator> bool operator<= (const reverse_iterator< _Iterator > &__x, const reverse_iterator< _Iterator > &__y)
- template<typename _Tp, typename _Alloc> bool operator<= (const deque< _Tp, _Alloc > &__x, const deque< _Tp, _Alloc > &__y)
- template<typename _Tp, typename _RefL, typename _PtrL, typename _RefR, typename _PtrR> bool operator<= (const _Deque_iterator< _Tp, _RefL, _PtrL > &__x, const _Deque_iterator< _Tp, _RefR, _PtrR > &__y)
- template<typename _Tp, typename _Ref, typename _Ptr> bool operator<= (const _Deque_iterator< _Tp, _Ref, _Ptr > &__x, const _Deque_iterator< _Tp, _Ref, _Ptr > &__y)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator<= (const _CharT *__lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator<= (const basic_string< _CharT, _Traits, _Alloc > &__lhs, const _CharT *__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator<= (const basic_string< _CharT, _Traits, _Alloc > &__lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<typename _CharT, typename _Traits> bool operator== (const istreambuf_iterator< _CharT, _Traits > &__a, const istreambuf_iterator< _CharT, _Traits > &__b)
- template<typename _Tp, typename _CharT, typename _Traits, typename _Dist> bool operator== (const istream_iterator< _Tp, _CharT, _Traits, _Dist > &__x, const istream_iterator< _Tp, _CharT, _Traits, _Dist > &__y)
- template<typename _Tp, typename _Alloc> bool operator== (const vector< _Tp, _Alloc > &__x, const vector< _Tp, _Alloc > &__y)
- template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc> bool operator== (const _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > &__x, const _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > &__y)
- template<typename _Val> bool operator== (const _Rb_tree_iterator< _Val > &__x, const _Rb_tree_const_iterator< _Val > &__y)
- template<typename _Tp, typename _Seq> bool operator== (const stack< _Tp, _Seq > &__x, const stack< _Tp, _Seq > &__y)
- template<class _Key, class _Compare, class _Alloc> bool operator== (const set< _Key, _Compare, _Alloc > &__x, const set< _Key, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Sequence> bool operator== (const queue< _Tp, _Sequence > &__x, const queue< _Tp, _Sequence > &__y)
- template<typename _Tp, typename _Seq> bool operator== (const queue< _Tp, _Seq > &, const queue< _Tp, _Seq > &)
- template<class _T1, class _T2> bool operator== (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
- template<class _Key, class _Compare, class _Alloc> bool operator== (const multiset< _Key, _Compare, _Alloc > &__x, const multiset< _Key, _Compare, _Alloc > &__y)
- template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> bool operator== (const multimap< _Key, _Tp, _Compare, _Alloc > &__x, const multimap< _Key, _Tp, _Compare, _Alloc > &__y)
- template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> bool operator== (const map< _Key, _Tp, _Compare, _Alloc > &__x, const map< _Key, _Tp, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Alloc> bool operator== (const list< _Tp, _Alloc > &__x, const list< _Tp, _Alloc > &__y)
- template<typename _Val> bool operator== (const _List_iterator< _Val > &__x, const _List_const_iterator< _Val > &__y)
- template<typename _Iterator> bool operator== (const reverse_iterator< _Iterator > &__x, const reverse_iterator< _Iterator > &__y)
- template<typename _Tp, typename _Alloc> bool operator== (const deque< _Tp, _Alloc > &__x, const deque< _Tp, _Alloc > &__y)
- template<typename _Tp, typename _RefL, typename _PtrL, typename _RefR, typename _PtrR> bool operator== (const _Deque_iterator< _Tp, _RefL, _PtrL > &__x, const _Deque_iterator< _Tp, _RefR, _PtrR > &__y)
- template<typename _Tp, typename _Ref, typename _Ptr> bool operator== (const _Deque_iterator< _Tp, _Ref, _Ptr > &__x, const _Deque_iterator< _Tp, _Ref, _Ptr > &__y)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator== (const basic_string< _CharT, _Traits, _Alloc > &__lhs, const _CharT *__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator== (const _CharT *__lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator== (const basic_string< _CharT, _Traits, _Alloc > &__lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<typename _T1, typename _T2> bool operator== (const allocator< _T1 > &, const allocator< _T2 > &)
- template<typename _Tp, typename _Alloc> bool operator> (const vector< _Tp, _Alloc > &__x, const vector< _Tp, _Alloc > &__y)
- template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc> bool operator> (const _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > &__x, const _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Seq> bool operator> (const stack< _Tp, _Seq > &__x, const stack< _Tp, _Seq > &__y)
- template<class _Key, class _Compare, class _Alloc> bool operator> (const set< _Key, _Compare, _Alloc > &__x, const set< _Key, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Sequence> bool operator> (const queue< _Tp, _Sequence > &__x, const queue< _Tp, _Sequence > &__y)
- template<class _T1, class _T2> bool operator> (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
- template<class _Key, class _Compare, class _Alloc> bool operator> (const multiset< _Key, _Compare, _Alloc > &__x, const multiset< _Key, _Compare, _Alloc > &__y)
- template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> bool operator> (const multimap< _Key, _Tp, _Compare, _Alloc > &__x, const multimap< _Key, _Tp, _Compare, _Alloc > &__y)
- template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> bool operator> (const map< _Key, _Tp, _Compare, _Alloc > &__x, const map< _Key, _Tp, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Alloc> bool operator> (const list< _Tp, _Alloc > &__x, const list< _Tp, _Alloc > &__y)
- template<typename _Iterator> bool operator> (const reverse_iterator< _Iterator > &__x, const reverse_iterator< _Iterator > &__y)
- template<typename _Tp, typename _Alloc> bool operator> (const deque< _Tp, _Alloc > &__x, const deque< _Tp, _Alloc > &__y)
- template<typename _Tp, typename _RefL, typename _PtrL, typename _RefR, typename _PtrR> bool operator> (const _Deque_iterator< _Tp, _RefL, _PtrL > &__x, const _Deque_iterator< _Tp, _RefR, _PtrR > &__y)
- template<typename _Tp, typename _Ref, typename _Ptr> bool operator> (const _Deque_iterator< _Tp, _Ref, _Ptr > &__x, const _Deque_iterator< _Tp, _Ref, _Ptr > &__y)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator> (const _CharT *__lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator> (const basic_string< _CharT, _Traits, _Alloc > &__lhs, const _CharT *__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator> (const basic_string< _CharT, _Traits, _Alloc > &__lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<typename _Tp, typename _Alloc> bool operator>= (const vector< _Tp, _Alloc > &__x, const vector< _Tp, _Alloc > &__y)
- template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc> bool operator>= (const _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > &__x, const _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Seq> bool operator>= (const stack< _Tp, _Seq > &__x, const stack< _Tp, _Seq > &__y)
- template<class _Key, class _Compare, class _Alloc> bool operator>= (const set< _Key, _Compare, _Alloc > &__x, const set< _Key, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Sequence> bool operator>= (const queue< _Tp, _Sequence > &__x, const queue< _Tp, _Sequence > &__y)
- template<class _T1, class _T2> bool operator>= (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
- template<class _Key, class _Compare, class _Alloc> bool operator>= (const multiset< _Key, _Compare, _Alloc > &__x, const multiset< _Key, _Compare, _Alloc > &__y)
- template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> bool operator>= (const multimap< _Key, _Tp, _Compare, _Alloc > &__x, const multimap< _Key, _Tp, _Compare, _Alloc > &__y)
- template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> bool operator>= (const map< _Key, _Tp, _Compare, _Alloc > &__x, const map< _Key, _Tp, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Alloc> bool operator>= (const list< _Tp, _Alloc > &__x, const list< _Tp, _Alloc > &__y)
- template<typename _Iterator> bool operator>= (const reverse_iterator< _Iterator > &__x, const reverse_iterator< _Iterator > &__y)
- template<typename _Tp, typename _Alloc> bool operator>= (const deque< _Tp, _Alloc > &__x, const deque< _Tp, _Alloc > &__y)
- template<typename _Tp, typename _RefL, typename _PtrL, typename _RefR, typename _PtrR> bool operator>= (const _Deque_iterator< _Tp, _RefL, _PtrL > &__x, const _Deque_iterator< _Tp, _RefR, _PtrR > &__y)
- template<typename _Tp, typename _Ref, typename _Ptr> bool operator>= (const _Deque_iterator< _Tp, _Ref, _Ptr > &__x, const _Deque_iterator< _Tp, _Ref, _Ptr > &__y)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator>= (const _CharT *__lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator>= (const basic_string< _CharT, _Traits, _Alloc > &__lhs, const _CharT *__rhs)
- template<typename _CharT, typename _Traits, typename _Alloc> bool operator>= (const basic_string< _CharT, _Traits, _Alloc > &__lhs, const basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<class _Traits> basic_istream< char, _Traits > & operator>> (basic_istream< char, _Traits > &__in, signed char *__s)
- template<class _Traits> basic_istream< char, _Traits > & operator>> (basic_istream< char, _Traits > &__in, unsigned char *__s)
- template<class _Traits> basic_istream< char, _Traits > & operator>> (basic_istream< char, _Traits > &__in, signed char &__c)
- template<class _Traits> basic_istream< char, _Traits > & operator>> (basic_istream< char, _Traits > &__in, unsigned char &__c)
- template<typename _CharT, typename _Traits> basic_istream< _CharT, _Traits > & operator>> (basic_istream< _CharT, _Traits > &__is, _Setw __f)
- template<typename _CharT, typename _Traits> basic_istream< _CharT, _Traits > & operator>> (basic_istream< _CharT, _Traits > &__is, _Setprecision __f)
- template<typename _CharT, typename _Traits> basic_istream< _CharT, _Traits > & operator>> (basic_istream< _CharT, _Traits > &__is, _Setfill< _CharT > __f)
- template<typename _CharT, typename _Traits> basic_istream< _CharT, _Traits > & operator>> (basic_istream< _CharT, _Traits > &__is, _Setbase __f)
- template<typename _CharT, typename _Traits> basic_istream< _CharT, _Traits > & operator>> (basic_istream< _CharT, _Traits > &__is, _Setiosflags __f)
- template<typename _CharT, typename _Traits> basic_istream< _CharT, _Traits > & operator>> (basic_istream< _CharT, _Traits > &__is, _Resetiosflags __f)
- template<class _CharT, class _Traits, size_t _Nb> basic_istream< _CharT, _Traits > & operator>> (basic_istream< _CharT, _Traits > &__is, bitset< _Nb > &__x)
- template<typename _CharT, typename _Traits> basic_istream< _CharT, _Traits > & operator>> (basic_istream< _CharT, _Traits > &__in, _CharT *__s)
- template<typename _CharT, typename _Traits> basic_istream< _CharT, _Traits > & operator>> (basic_istream< _CharT, _Traits > &__in, _CharT &__c)
- template<typename _CharT, typename _Traits, typename _Alloc> basic_istream< _CharT, _Traits > & operator>> (basic_istream< _CharT, _Traits > &__is, basic_string< _CharT, _Traits, _Alloc > &__str)
- template<size_t _Nb> bitset< _Nb > operator^ (const bitset< _Nb > &__x, const bitset< _Nb > &__y)
- _Ios_Iostate operator^ (_Ios_Iostate __a, _Ios_Iostate __b)
- _Ios_Openmode operator^ (_Ios_Openmode __a, _Ios_Openmode __b)
- _Ios_Fmtflags operator^ (_Ios_Fmtflags __a, _Ios_Fmtflags __b)
- _Ios_Iostate & operator^= (_Ios_Iostate &__a, _Ios_Iostate __b)
- _Ios_Openmode & operator^= (_Ios_Openmode &__a, _Ios_Openmode __b)
- _Ios_Fmtflags & operator^= (_Ios_Fmtflags &__a, _Ios_Fmtflags __b)
- template<size_t _Nb> bitset< _Nb > operator| (const bitset< _Nb > &__x, const bitset< _Nb > &__y)
- _Ios_Iostate operator| (_Ios_Iostate __a, _Ios_Iostate __b)
- _Ios_Openmode operator| (_Ios_Openmode __a, _Ios_Openmode __b)
- _Ios_Fmtflags operator| (_Ios_Fmtflags __a, _Ios_Fmtflags __b)
- _Ios_Iostate & operator|= (_Ios_Iostate &__a, _Ios_Iostate __b)
- _Ios_Openmode & operator|= (_Ios_Openmode &__a, _Ios_Openmode __b)
- _Ios_Fmtflags & operator|= (_Ios_Fmtflags &__a, _Ios_Fmtflags __b)
- _Ios_Iostate operator~ (_Ios_Iostate __a)
- _Ios_Openmode operator~ (_Ios_Openmode __a)
- _Ios_Fmtflags operator~ (_Ios_Fmtflags __a)
- template<typename _RandomAccessIterator, typename _Compare> void partial_sort (_RandomAccessIterator __first, _RandomAccessIterator __middle, _RandomAccessIterator __last, _Compare __comp)
- template<typename _RandomAccessIterator> void partial_sort (_RandomAccessIterator __first, _RandomAccessIterator __middle, _RandomAccessIterator __last)
- template<typename _InputIterator, typename _RandomAccessIterator, typename _Compare> _RandomAccessIterator partial_sort_copy (_InputIterator __first, _InputIterator __last, _RandomAccessIterator __result_first, _RandomAccessIterator __result_last, _Compare __comp)
- template<typename _InputIterator, typename _RandomAccessIterator> _RandomAccessIterator partial_sort_copy (_InputIterator __first, _InputIterator __last, _RandomAccessIterator __result_first, _RandomAccessIterator __result_last)
- template<typename _InputIterator, typename _OutputIterator, typename _BinaryOperation> _OutputIterator partial_sum (_InputIterator __first, _InputIterator __last, _OutputIterator __result, _BinaryOperation __binary_op)
- template<typename _InputIterator, typename _OutputIterator> _OutputIterator partial_sum (_InputIterator __first, _InputIterator __last, _OutputIterator __result)
- template<typename _ForwardIterator, typename _Predicate> _ForwardIterator partition (_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred)
- template<typename _RandomAccessIterator, typename _Compare> void pop_heap (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
- template<typename _RandomAccessIterator> void pop_heap (_RandomAccessIterator __first, _RandomAccessIterator __last)
- template<typename _BidirectionalIterator, typename _Compare> bool prev_permutation (_BidirectionalIterator __first, _BidirectionalIterator __last, _Compare __comp)
- template<typename _BidirectionalIterator> bool prev_permutation (_BidirectionalIterator __first, _BidirectionalIterator __last)
- template<class _Arg1, class _Arg2, class _Result> pointer_to_binary_function<
  _Arg1, _Arg2, _Result > ptr_fun (_Result(*__x)(_Arg1, _Arg2))
- template<class _Arg, class _Result> pointer_to_unary_function<
  _Arg, _Result > ptr_fun (_Result(*__x)(_Arg))
- template<typename _RandomAccessIterator, typename _Compare> void push_heap (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
- template<typename _RandomAccessIterator> void push_heap (_RandomAccessIterator __first, _RandomAccessIterator __last)
- template<typename _RandomAccessIterator, typename _RandomNumberGenerator> void random_shuffle (_RandomAccessIterator __first, _RandomAccessIterator __last, _RandomNumberGenerator &__rand)
- template<typename _RandomAccessIterator> void random_shuffle (_RandomAccessIterator __first, _RandomAccessIterator __last)
- template<typename _ForwardIterator, typename _Tp> _ForwardIterator remove (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__value)
- template<typename _InputIterator, typename _OutputIterator, typename _Tp> _OutputIterator remove_copy (_InputIterator __first, _InputIterator __last, _OutputIterator __result, const _Tp &__value)
- template<typename _InputIterator, typename _OutputIterator, typename _Predicate> _OutputIterator remove_copy_if (_InputIterator __first, _InputIterator __last, _OutputIterator __result, _Predicate __pred)
- template<typename _ForwardIterator, typename _Predicate> _ForwardIterator remove_if (_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred)
- template<typename _ForwardIterator, typename _Tp> void replace (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__old_value, const _Tp &__new_value)
- template<typename _InputIterator, typename _OutputIterator, typename _Tp> _OutputIterator replace_copy (_InputIterator __first, _InputIterator __last, _OutputIterator __result, const _Tp &__old_value, const _Tp &__new_value)
- template<typename _InputIterator, typename _OutputIterator, typename _Predicate, typename _Tp> _OutputIterator replace_copy_if (_InputIterator __first, _InputIterator __last, _OutputIterator __result, _Predicate __pred, const _Tp &__new_value)
- template<typename _ForwardIterator, typename _Predicate, typename _Tp> void replace_if (_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred, const _Tp &__new_value)
- _Resetiosflags resetiosflags (ios_base::fmtflags __mask)
- template<typename _Tp> void return_temporary_buffer (_Tp *__p)
- template<typename _BidirectionalIterator> void reverse (_BidirectionalIterator __first, _BidirectionalIterator __last)
- template<typename _BidirectionalIterator, typename _OutputIterator> _OutputIterator reverse_copy (_BidirectionalIterator __first, _BidirectionalIterator __last, _OutputIterator __result)
- ios_base & right (ios_base &__base)
- template<typename _ForwardIterator> void rotate (_ForwardIterator __first, _ForwardIterator __middle, _ForwardIterator __last)
- template<typename _ForwardIterator, typename _OutputIterator> _OutputIterator rotate_copy (_ForwardIterator __first, _ForwardIterator __middle, _ForwardIterator __last, _OutputIterator __result)
- ios_base & scientific (ios_base &__base)
- template<typename _ForwardIterator1, typename _ForwardIterator2, typename _BinaryPredicate> _ForwardIterator1 search (_ForwardIterator1 __first1, _ForwardIterator1 __last1, _ForwardIterator2 __first2, _ForwardIterator2 __last2, _BinaryPredicate __predicate)
- template<typename _ForwardIterator1, typename _ForwardIterator2> _ForwardIterator1 search (_ForwardIterator1 __first1, _ForwardIterator1 __last1, _ForwardIterator2 __first2, _ForwardIterator2 __last2)
- template<typename _ForwardIterator, typename _Integer, typename _Tp, typename _BinaryPredicate> _ForwardIterator search_n (_ForwardIterator __first, _ForwardIterator __last, _Integer __count, const _Tp &__val, _BinaryPredicate __binary_pred)
- template<typename _ForwardIterator, typename _Integer, typename _Tp> _ForwardIterator search_n (_ForwardIterator __first, _ForwardIterator __last, _Integer __count, const _Tp &__val)
- template<typename _InputIterator1, typename _InputIterator2, typename _OutputIterator, typename _Compare> _OutputIterator set_difference (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)
- template<typename _InputIterator1, typename _InputIterator2, typename _OutputIterator> _OutputIterator set_difference (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result)
- template<typename _InputIterator1, typename _InputIterator2, typename _OutputIterator, typename _Compare> _OutputIterator set_intersection (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)
- template<typename _InputIterator1, typename _InputIterator2, typename _OutputIterator> _OutputIterator set_intersection (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result)
- new_handler set_new_handler (new_handler) throw ()
- template<typename _InputIterator1, typename _InputIterator2, typename _OutputIterator, typename _Compare> _OutputIterator set_symmetric_difference (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)
- template<typename _InputIterator1, typename _InputIterator2, typename _OutputIterator> _OutputIterator set_symmetric_difference (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result)
- terminate_handler set_terminate (terminate_handler) throw ()
- unexpected_handler set_unexpected (unexpected_handler) throw ()
- template<typename _InputIterator1, typename _InputIterator2, typename _OutputIterator, typename _Compare> _OutputIterator set_union (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)
- template<typename _InputIterator1, typename _InputIterator2, typename _OutputIterator> _OutputIterator set_union (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result)
- _Setbase setbase (int __base)
- template<typename _CharT> _Setfill< _CharT > setfill (_CharT __c)
- _Setiosflags setiosflags (ios_base::fmtflags __mask)
- _Setprecision setprecision (int __n)
- _Setw setw (int __n)
- ios_base & showbase (ios_base &__base)
- ios_base & showpoint (ios_base &__base)
- ios_base & showpos (ios_base &__base)
- ios_base & skipws (ios_base &__base)
- template<typename _RandomAccessIterator, typename _Compare> void sort (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
- template<typename _RandomAccessIterator> void sort (_RandomAccessIterator __first, _RandomAccessIterator __last)
- template<typename _RandomAccessIterator, typename _Compare> void sort_heap (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
- template<typename _RandomAccessIterator> void sort_heap (_RandomAccessIterator __first, _RandomAccessIterator __last)
- template<typename _ForwardIterator, typename _Predicate> _ForwardIterator stable_partition (_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred)
- template<typename _RandomAccessIterator, typename _Compare> void stable_sort (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
- template<typename _RandomAccessIterator> void stable_sort (_RandomAccessIterator __first, _RandomAccessIterator __last)
- template<typename _Tp, typename _Alloc> void swap (vector< _Tp, _Alloc > &__x, vector< _Tp, _Alloc > &__y)
- template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc> void swap (_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > &__x, _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > &__y)
- template<class _Key, class _Compare, class _Alloc> void swap (set< _Key, _Compare, _Alloc > &__x, set< _Key, _Compare, _Alloc > &__y)
- template<class _Key, class _Compare, class _Alloc> void swap (multiset< _Key, _Compare, _Alloc > &__x, multiset< _Key, _Compare, _Alloc > &__y)
- template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> void swap (multimap< _Key, _Tp, _Compare, _Alloc > &__x, multimap< _Key, _Tp, _Compare, _Alloc > &__y)
- template<typename _Key, typename _Tp, typename _Compare, typename _Alloc> void swap (map< _Key, _Tp, _Compare, _Alloc > &__x, map< _Key, _Tp, _Compare, _Alloc > &__y)
- template<typename _Tp, typename _Alloc> void swap (list< _Tp, _Alloc > &__x, list< _Tp, _Alloc > &__y)
- template<typename _Tp, typename _Alloc> void swap (deque< _Tp, _Alloc > &__x, deque< _Tp, _Alloc > &__y)
- template<typename _Tp> void swap (_Tp &__a, _Tp &__b)
- template<typename _CharT, typename _Traits, typename _Alloc> void swap (basic_string< _CharT, _Traits, _Alloc > &__lhs, basic_string< _CharT, _Traits, _Alloc > &__rhs)
- template<typename _ForwardIterator1, typename _ForwardIterator2> _ForwardIterator2 swap_ranges (_ForwardIterator1 __first1, _ForwardIterator1 __last1, _ForwardIterator2 __first2)
- void terminate () __attribute__((__noreturn__))
- template<typename _CharT> _CharT tolower (_CharT __c, const locale &__loc)
- template<typename _CharT> _CharT toupper (_CharT __c, const locale &__loc)
- template<typename _InputIterator1, typename _InputIterator2, typename _OutputIterator, typename _BinaryOperation> _OutputIterator transform (_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _OutputIterator __result, _BinaryOperation __binary_op)
- template<typename _InputIterator, typename _OutputIterator, typename _UnaryOperation> _OutputIterator transform (_InputIterator __first, _InputIterator __last, _OutputIterator __result, _UnaryOperation __unary_op)
- bool uncaught_exception () throw ()
- void unexpected () __attribute__((__noreturn__))
- wchar_t * uninitialized_copy (const wchar_t *__first, const wchar_t *__last, wchar_t *__result)
- char * uninitialized_copy (const char *__first, const char *__last, char *__result)
- template<typename _InputIterator, typename _ForwardIterator> _ForwardIterator uninitialized_copy (_InputIterator __first, _InputIterator __last, _ForwardIterator __result)
- template<typename _ForwardIterator, typename _Tp> void uninitialized_fill (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__x)
- template<typename _ForwardIterator, typename _Size, typename _Tp> void uninitialized_fill_n (_ForwardIterator __first, _Size __n, const _Tp &__x)
- template<typename _ForwardIterator, typename _BinaryPredicate> _ForwardIterator unique (_ForwardIterator __first, _ForwardIterator __last, _BinaryPredicate __binary_pred)
- template<typename _ForwardIterator> _ForwardIterator unique (_ForwardIterator __first, _ForwardIterator __last)
- template<typename _InputIterator, typename _OutputIterator, typename _BinaryPredicate> _OutputIterator unique_copy (_InputIterator __first, _InputIterator __last, _OutputIterator __result, _BinaryPredicate __binary_pred)
- template<typename _InputIterator, typename _OutputIterator> _OutputIterator unique_copy (_InputIterator __first, _InputIterator __last, _OutputIterator __result)
- ios_base & unitbuf (ios_base &__base)
- template<typename _ForwardIterator, typename _Tp, typename _Compare> _ForwardIterator upper_bound (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__val, _Compare __comp)
- template<typename _ForwardIterator, typename _Tp> _ForwardIterator upper_bound (_ForwardIterator __first, _ForwardIterator __last, const _Tp &__val)
- ios_base & uppercase (ios_base &__base)
- template<typename _Facet> const _Facet & use_facet (const locale &__loc)
- template<> const ctype< char > & use_facet< ctype< char > > (const locale &__loc)
- template<> const ctype< wchar_t > & use_facet< ctype< wchar_t > > (const locale &__loc)
- template<typename _CharT, typename _Traits> basic_istream< _CharT, _Traits > & ws (basic_istream< _CharT, _Traits > &__in)

## Variables

- static ios_base::Init __ioinit
- const nothrow_t nothrow

## Typedef Documentation

typedef void(* new_handler)()

| If you write your own error handler to be called by `new`, it must be of this type. Definition at line 68 of file new.

typedef long long streamoff

| Type used by fpos, char_traits<char>, and char_traits<wchar_t>. Definition at line 74 of file postypes.h.

typedef fpos<mbstate_t> streampos

| File position for char streams. Definition at line 210 of file postypes.h.

typedef ptrdiff_t streamsize

| Integral type for I/O operation counts and buffer sizes. Definition at line 78 of file postypes.h.

typedef void(* terminate_handler)()

| If you write a replacement terminate handler, it must be of this type. Definition at line 76 of file exception.

typedef void(* unexpected_handler)()

| If you write a replacement unexpected handler, it must be of this type. Definition at line 78 of file exception.

typedef fpos<mbstate_t> wstreampos

| File position for wchar_t streams. Definition at line 212 of file postypes.h.

## Enumeration Type Documentation

enum float_denorm_style

Describes the denormalization for floating-point types.

These values represent the presence or absence of a variable number of exponent bits. This type is used in the std::numeric_limits class.

Enumeration values:

  denorm_indeterminate | Indeterminate at compile time whether denormalized values are allowed.
  denorm_absent | The type does not allow denormalized values.
  denorm_present | The type allows denormalized values.

Definition at line 171 of file limits.

enum float_round_style

Describes the rounding style for floating-point types.

This is used in the std::numeric_limits class.

Enumeration values:

  round_indeterminate | Self-explanatory.
  round_toward_zero | Self-explanatory.
  round_to_nearest | To the nearest representable value.
  round_toward_infinity | Self-explanatory.
  round_toward_neg_infinity | Self-explanatory.

Definition at line 156 of file limits.

## Function Documentation

_Tp std::accumulate | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _Tp | __init,
|  | _BinaryOperation | __binary_op
| ) |

Accumulate values in a range with operation.

Accumulates the values in the range [first,last) using the function object binary_op. The initial value is init. The values are processed in order.

Parameters:

  | first | Start of range.
  | last | End of range.
  | init | Starting value to add other values to.
  | binary_op | Function object to accumulate with.

Returns:
  The final sum.

Definition at line 108 of file stl_numeric.h.

_Tp std::accumulate | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _Tp | __init
| ) |

Accumulate values in a range.

Accumulates the values in the range [first,last) using operator+(). The initial value is init. The values are processed in order.

Parameters:

  | first | Start of range.
  | last | End of range.
  | init | Starting value to add other values to.

Returns:
  The final sum.

Definition at line 82 of file stl_numeric.h.

_OutputIterator std::adjacent_difference | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _OutputIterator | __result,
|  | _BinaryOperation | __binary_op
| ) |

Return differences between adjacent values.

Computes the difference between adjacent values in the range [first,last) using the function object binary_op and writes the result to result.

Parameters:

  | first | Start of input range.
  | last | End of input range.
  | result | Output to write sums to.

Returns:
  Iterator pointing just beyond the values written to result.

Definition at line 314 of file stl_numeric.h.

_OutputIterator std::adjacent_difference | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _OutputIterator | __result
| ) |

Return differences between adjacent values.

Computes the difference between adjacent values in the range [first,last) using operator-() and writes the result to result.

Parameters:

  | first | Start of input range.
  | last | End of input range.
  | result | Output to write sums to.

Returns:
  Iterator pointing just beyond the values written to result.

Definition at line 275 of file stl_numeric.h.

_ForwardIterator std::adjacent_find | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | _BinaryPredicate | __binary_pred
| ) |

Find two adjacent values in a sequence using a predicate.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.
  | binary_pred | A binary predicate.

Returns:
  The first iterator `i` such that `i` and `i+1` are both valid iterators in ``[first,last) and such that `binary_pred`(*i,*(i+1)) is true, or `last` if no such iterator exists.

Definition at line 381 of file stl_algo.h.

_ForwardIterator std::adjacent_find | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last
| ) |

Find two adjacent values in a sequence that are equal.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.

Returns:
  The first iterator `i` such that `i` and `i+1` are both valid iterators in ``[first,last) and such that `*i` == `*`(i+1), or `last` if no such iterator exists.

Definition at line 350 of file stl_algo.h.

Referenced by unique().

void std::advance | ( | _InputIterator & | __i,
|  | _Distance | __n
| ) | `[inline]`

A generalization of pointer arithmetic.

Parameters:

  | i | An input iterator.
  | n | The "delta" by which to change `i`.

Returns:
  Nothing.

This increments `i` by `n`. For bidirectional and random access iterators, `n` may be negative, in which case `i` is decremented.

For random access iterators, this uses their `+` and `-` operations and are constant time. For other iterator classes they are linear time.

Definition at line 172 of file stl_iterator_base_funcs.h.

Referenced by equal_range(), lower_bound(), and upper_bound().

back_insert_iterator<_Container> std::back_inserter | ( | _Container & | __x | ) | `[inline]`

Parameters:

  | x | A container of arbitrary type.

Returns:
  An instance of back_insert_iterator working on `x`.

This wrapper function helps in creating back_insert_iterator instances. Typing the name of the iterator requires knowing the precise full type of the container, which can be tedious and impedes generic programming. Using this function lets you take advantage of automatic template parameter deduction, making the compiler match the correct types for you.

Definition at line 397 of file stl_iterator.h.

ios_base& std::boolalpha | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::boolalpha). Definition at line 788 of file ios_base.h. References ios_base::boolalpha, and ios_base::setf().

_OutputIterator std::copy | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _OutputIterator | __result
| ) | `[inline]`

Copies the range [first,last) into result.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | result | An output iterator.

Returns:
  result + (first - last)

This inline function will boil down to a call to `memmove` whenever possible. Failing that, if random access iterators are passed, then the loop count will be known (and therefore a candidate for compiler optimizations such as unrolling). Result may not be contained within [first,last); the copy_backward function should be used instead.

Note that the end of the output range is permitted to be contained within [first,last).

Definition at line 375 of file stl_algobase.h.

References __gnu_cxx::copy_n().

Referenced by codecvt< _InternT, _ExternT, encoding_state >::do_out(), vector::erase(), deque::erase(), merge(), vector::operator=(), deque::operator=(), rotate_copy(), set_difference(), set_symmetric_difference(), set_union(), basic_filebuf::underflow(), basic_streambuf::xsgetn(), and basic_streambuf::xsputn().

_BI2 std::copy_backward | ( | _BI1 | __first,
|  | _BI1 | __last,
|  | _BI2 | __result
| ) | `[inline]`

Copies the range [first,last) into result.

Parameters:

  | first | A bidirectional iterator.
  | last | A bidirectional iterator.
  | result | A bidirectional iterator.

Returns:
  result - (first - last)

The function has the same effect as copy, but starts at the end of the range and works its way to the start, returning the start of the result. This inline function will boil down to a call to `memmove` whenever possible. Failing that, if random access iterators are passed, then the loop count will be known (and therefore a candidate for compiler optimizations such as unrolling).

Result may not be in the range [first,last). Use copy instead. Note that the start of the output range may overlap [first,last).

Definition at line 504 of file stl_algobase.h.

Referenced by deque::erase().

iterator_traits<_InputIterator>::difference_type std::count | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const _Tp & | __value
| ) |

Count the number of copies of a value in a sequence.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | value | The value to be counted.

Returns:
  The number of iterators `i` in the range ``[first,last) for which `*i` == `value`

Definition at line 412 of file stl_algo.h.

iterator_traits<_InputIterator>::difference_type std::count_if | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _Predicate | __pred
| ) |

Count the elements of a sequence for which a predicate is true.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | pred | A predicate.

Returns:
  The number of iterators `i` in the range ``[first,last) for which `pred(*i)` is true.

Definition at line 437 of file stl_algo.h.

ios_base& std::dec | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::dec, ios_base::basefield). Definition at line 926 of file ios_base.h. References ios_base::basefield, and ios_base::dec.

iterator_traits<_InputIterator>::difference_type std::distance | ( | _InputIterator | __first,
|  | _InputIterator | __last
| ) | `[inline]`

A generalization of pointer arithmetic.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

Returns:
  The distance between them.

Returns `n` such that first + n == last. This requires that `last` must be reachable from `first`. Note that `n` may be negative.

For random access iterators, this uses their `+` and `-` operations and are constant time. For other iterator classes they are linear time.

Definition at line 114 of file stl_iterator_base_funcs.h.

Referenced by equal_range(), inplace_merge(), lower_bound(), __gnu_cxx::random_sample_n(), list::size(), and upper_bound().

basic_ostream<_CharT, _Traits>& std::endl | ( | basic_ostream< _CharT, _Traits > & | __os | ) |

| Write a newline and flush the stream. This manipulator is often mistakenly used when a simple newline is desired, leading to poor buffering performance. See http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#2 for more on this subject. Definition at line 517 of file ostream. References flush().

basic_ostream<_CharT, _Traits>& std::ends | ( | basic_ostream< _CharT, _Traits > & | __os | ) |

| Write a null character into the output sequence. "Null character" is `CharT()` by definition. For CharT of `char`, this correctly writes the ASCII `NUL` character string terminator. Definition at line 528 of file ostream. References basic_ostream::put().

bool std::equal | ( | _InputIterator1 | __first1,
|  | _InputIterator1 | __last1,
|  | _InputIterator2 | __first2,
|  | _BinaryPredicate | __binary_pred
| ) | `[inline]`

Tests a range for element-wise equality.

Parameters:

  | first1 | An input iterator.
  | last1 | An input iterator.
  | first2 | An input iterator.
  | binary_pred | A binary predicate functor.

Returns:
  A boolean true or false.

This compares the elements of two ranges using the binary_pred parameter, and returns true or false depending on whether all of the corresponding elements of the ranges are equal.

Definition at line 781 of file stl_algobase.h.

bool std::equal | ( | _InputIterator1 | __first1,
|  | _InputIterator1 | __last1,
|  | _InputIterator2 | __first2
| ) | `[inline]`

Tests a range for element-wise equality.

Parameters:

  | first1 | An input iterator.
  | last1 | An input iterator.
  | first2 | An input iterator.

Returns:
  A boolean true or false.

This compares the elements of two ranges using `==` and returns true or false depending on whether all of the corresponding elements of the ranges are equal.

Definition at line 748 of file stl_algobase.h.

Referenced by operator==().

void std::fill | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | const _Tp & | __value
| ) |

Fills the range [first,last) with copies of value.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.
  | value | A reference-to-const of arbitrary type.

Returns:
  Nothing.

This function fills a range with copies of the same value. For one-byte types filling contiguous areas of memory, this becomes an inline call to `memset`.

Definition at line 560 of file stl_algobase.h.

_OutputIterator std::fill_n | ( | _OutputIterator | __first,
|  | _Size | __n,
|  | const _Tp & | __value
| ) |

Fills the range [first,first+n) with copies of value.

Parameters:

  | first | An output iterator.
  | n | The count of copies to perform.
  | value | A reference-to-const of arbitrary type.

Returns:
  The iterator at first+n.

This function fills a range with copies of the same value. For one-byte types filling contiguous areas of memory, this becomes an inline call to `memset`.

Definition at line 636 of file stl_algobase.h.

_InputIterator std::find | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const _Tp & | __val
| ) | `[inline]`

Find the first occurrence of a value in a sequence.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | val | The value to find.

Returns:
  The first iterator `i` in the range ``[first,last) such that `*i` == `val`, or `last` if no such iterator exists.

Definition at line 306 of file stl_algo.h.

_ForwardIterator1 std::find_end | ( | _ForwardIterator1 | __first1,
|  | _ForwardIterator1 | __last1,
|  | _ForwardIterator2 | __first2,
|  | _ForwardIterator2 | __last2,
|  | _BinaryPredicate | __comp
| ) | `[inline]`

Find last matching subsequence in a sequence using a predicate.

Parameters:

  | first1 | Start of range to search.
  | last1 | End of range to search.
  | first2 | Start of sequence to match.
  | last2 | End of sequence to match.
  | comp | The predicate to use.

Returns:
  The last iterator `i` in the range ``[first1,last1-(last2-first2)) such that `predicate`(*(i+N), ``(first2+N)) is true for each `N` in the range ``[0,last2-first2), or `last1` if no such iterator exists.

Searches the range ``[first1,last1) for a sub-sequence that compares equal value-by-value with the sequence given by ``[first2,last2) using comp as a predicate and returns an iterator to the first element of the sub-sequence, or `last1` if the sub-sequence is not found. The sub-sequence will be the last such subsequence contained in [first,last1).

Because the sub-sequence must lie completely within the range ``[first1,last1) it must start at a position less than `last1-`(last2-first2) where `last2-first2` is the length of the sub-sequence. This means that the returned iterator `i` will be in the range ``[first1,last1-(last2-first2))

Definition at line 5144 of file stl_algo.h.

_ForwardIterator1 std::find_end | ( | _ForwardIterator1 | __first1,
|  | _ForwardIterator1 | __last1,
|  | _ForwardIterator2 | __first2,
|  | _ForwardIterator2 | __last2
| ) | `[inline]`

Find last matching subsequence in a sequence.

Parameters:

  | first1 | Start of range to search.
  | last1 | End of range to search.
  | first2 | Start of sequence to match.
  | last2 | End of sequence to match.

Returns:
  The last iterator `i` in the range ``[first1,last1-(last2-first2)) such that `*`(i+N) == `*`(first2+N) for each `N` in the range ``[0,last2-first2), or `last1` if no such iterator exists.

Searches the range ``[first1,last1) for a sub-sequence that compares equal value-by-value with the sequence given by ``[first2,last2) and returns an iterator to the first element of the sub-sequence, or `last1` if the sub-sequence is not found. The sub-sequence will be the last such subsequence contained in [first,last1).

Because the sub-sequence must lie completely within the range ``[first1,last1) it must start at a position less than `last1-`(last2-first2) where `last2-first2` is the length of the sub-sequence. This means that the returned iterator `i` will be in the range ``[first1,last1-(last2-first2))

Definition at line 5098 of file stl_algo.h.

_InputIterator std::find_first_of | ( | _InputIterator | __first1,
|  | _InputIterator | __last1,
|  | _ForwardIterator | __first2,
|  | _ForwardIterator | __last2,
|  | _BinaryPredicate | __comp
| ) |

Find element from a set in a sequence using a predicate.

Parameters:

  | first1 | Start of range to search.
  | last1 | End of range to search.
  | first2 | Start of match candidates.
  | last2 | End of match candidates.
  | comp | Predicate to use.

Returns:
  The first iterator `i` in the range ``[first1,last1) such that `comp`(*i, `*`(i2)) is true and i2 is an interator in [first2,last2), or `last1` if no such iterator exists.

Searches the range ``[first1,last1) for an element that is equal to some element in the range [first2,last2). If found, returns an iterator in the range [first1,last1), otherwise returns `last1`.

Definition at line 4919 of file stl_algo.h.

_InputIterator std::find_first_of | ( | _InputIterator | __first1,
|  | _InputIterator | __last1,
|  | _ForwardIterator | __first2,
|  | _ForwardIterator | __last2
| ) |

Find element from a set in a sequence.

Parameters:

  | first1 | Start of range to search.
  | last1 | End of range to search.
  | first2 | Start of match candidates.
  | last2 | End of match candidates.

Returns:
  The first iterator `i` in the range ``[first1,last1) such that `*i` == `*`(i2) such that i2 is an interator in [first2,last2), or `last1` if no such iterator exists.

Searches the range ``[first1,last1) for an element that is equal to some element in the range [first2,last2). If found, returns an iterator in the range [first1,last1), otherwise returns `last1`.

Definition at line 4882 of file stl_algo.h.

_InputIterator std::find_if | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _Predicate | __pred
| ) | `[inline]`

Find the first element in a sequence for which a predicate is true.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | pred | A predicate.

Returns:
  The first iterator `i` in the range ``[first,last) such that `pred(*i)` is true, or `last` if no such iterator exists.

Definition at line 328 of file stl_algo.h.

ios_base& std::fixed | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::fixed, ios_base::floatfield). Definition at line 951 of file ios_base.h. References ios_base::fixed, and ios_base::floatfield.

basic_ostream<_CharT, _Traits>& std::flush | ( | basic_ostream< _CharT, _Traits > & | __os | ) |

| Flushes the output stream. This manipulator simply calls the stream's `flush()` member function. Definition at line 538 of file ostream. References basic_ostream::flush(). Referenced by endl().

_Function std::for_each | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _Function | __f
| ) |

Apply a function to every element of a sequence.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | f | A unary function object.

Returns:
  `f`.

Applies the function object `f` to each element in the range ``[first,last). `f` must not modify the order of the sequence. If `f` has a return value it is ignored.

Definition at line 152 of file stl_algo.h.

front_insert_iterator<_Container> std::front_inserter | ( | _Container & | __x | ) | `[inline]`

Parameters:

  | x | A container of arbitrary type.

Returns:
  An instance of front_insert_iterator working on `x`.

This wrapper function helps in creating front_insert_iterator instances. Typing the name of the iterator requires knowing the precise full type of the container, which can be tedious and impedes generic programming. Using this function lets you take advantage of automatic template parameter deduction, making the compiler match the correct types for you.

Definition at line 471 of file stl_iterator.h.

void std::generate | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | _Generator | __gen
| ) |

Assign the result of a function object to each value in a sequence.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.
  | gen | A function object taking no arguments.

Returns:
  generate() returns no value.

Performs the assignment `*i` = `gen()` for each `i` in the range ``[first,last).

Definition at line 972 of file stl_algo.h.

_OutputIterator std::generate_n | ( | _OutputIterator | __first,
|  | _Size | __n,
|  | _Generator | __gen
| ) |

Assign the result of a function object to each value in a sequence.

Parameters:

  | first | A forward iterator.
  | n | The length of the sequence.
  | gen | A function object taking no arguments.

Returns:
  The end of the sequence, `first+n`

Performs the assignment `*i` = `gen()` for each `i` in the range ``[first,first+n).

Definition at line 998 of file stl_algo.h.

pair<_Tp*, ptrdiff_t> std::get_temporary_buffer | ( | ptrdiff_t | __len | ) | `[inline]`

Allocates a temporary buffer.

Parameters:

  | len | The number of objects of type Tp.

Returns:
  See full description.

Reinventing the wheel, but this time with prettier spokes!

This function tries to obtain storage for `len` adjacent Tp objects. The objects themselves are not constructed, of course. A pair<> is returned containing "the buffer s address and capacity (in the units of sizeof(Tp)), or a pair of 0 values if no storage can be obtained." Note that the capacity obtained may be less than that requested if the memory is unavailable; you should compare len with the .second return value.

Provides the nothrow exception guarantee.

Definition at line 110 of file memory.

basic_istream< _CharT, _Traits > & getline | ( | basic_istream< _CharT, _Traits > & | __is,
|  | basic_string< _CharT, _Traits, _Alloc > & | __str
| ) | `[inline]`

Read a line from stream into a string.

Parameters:

  | is | Input stream.
  | str | Buffer to store into.

Returns:
  Reference to the input stream.

Stores characters from is into str until '
' is found, the end of the stream is encountered, or str.max_size() is reached. If is.width() is non-zero, that is the limit on the number of characters stored into str. Any previous contents of str are erased. If end of line was encountered, it is extracted but not stored into str.

Definition at line 1256 of file istream.tcc.

References getline().

basic_istream< _CharT, _Traits > & getline | ( | basic_istream< _CharT, _Traits > & | __is,
|  | basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | _CharT | __delim
| ) |

Read a line from stream into a string.

Parameters:

  | is | Input stream.
  | str | Buffer to store into.
  | delim | Character marking end of line.

Returns:
  Reference to the input stream.

Stores characters from is into str until delim is found, the end of the stream is encountered, or str.max_size() is reached. If is.width() is non-zero, that is the limit on the number of characters stored into str. Any previous contents of str are erased. If delim was encountered, it is extracted but not stored into str.

Definition at line 1196 of file istream.tcc.

References ios_base::badbit, ios_base::eofbit, basic_string::erase(), ios_base::failbit, ios_base::goodbit, and basic_string::max_size().

Referenced by getline().

bool has_facet | ( | const locale & | __loc | ) | throw ()`[inline]`

Test for the presence of a facet.

has_facet tests the locale argument for the presence of the facet type provided as the template parameter. Facets derived from the facet parameter will also return true.

Parameters:

  | Facet | The facet type to test the presence of.
  | locale | The locale to test.

Returns:
  true if locale contains a facet of type Facet, else false.

Definition at line 88 of file locale_facets.tcc.

ios_base& std::hex | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::hex, ios_base::basefield). Definition at line 934 of file ios_base.h. References ios_base::basefield, and ios_base::hex.

_Tp std::inner_product | ( | _InputIterator1 | __first1,
|  | _InputIterator1 | __last1,
|  | _InputIterator2 | __first2,
|  | _Tp | __init,
|  | _BinaryOperation1 | __binary_op1,
|  | _BinaryOperation2 | __binary_op2
| ) |

Compute inner product of two ranges.

Starting with an initial value of init, applies binary_op2 to successive elements from the two ranges and accumulates each result into the accumulated value using binary_op1. The values in the ranges are processed in order.

Parameters:

  | first1 | Start of range 1.
  | last1 | End of range 1.
  | first2 | Start of range 2.
  | init | Starting value to add other values to.
  | binary_op1 | Function object to accumulate with.
  | binary_op2 | Function object to apply to pairs of input values.

Returns:
  The final inner product.

Definition at line 168 of file stl_numeric.h.

_Tp std::inner_product | ( | _InputIterator1 | __first1,
|  | _InputIterator1 | __last1,
|  | _InputIterator2 | __first2,
|  | _Tp | __init
| ) |

Compute inner product of two ranges.

Starting with an initial value of init, multiplies successive elements from the two ranges and adds each product into the accumulated value using operator+(). The values in the ranges are processed in order.

Parameters:

  | first1 | Start of range 1.
  | last1 | End of range 1.
  | first2 | Start of range 2.
  | init | Starting value to add other values to.

Returns:
  The final inner product.

Definition at line 136 of file stl_numeric.h.

void std::inplace_merge | ( | _BidirectionalIterator | __first,
|  | _BidirectionalIterator | __middle,
|  | _BidirectionalIterator | __last,
|  | _Compare | __comp
| ) |

Merges two sorted ranges in place.

Parameters:

  | first | An iterator.
  | middle | Another iterator.
  | last | Another iterator.
  | comp | A functor to use for comparisons.

Returns:
  Nothing.

Merges two sorted and consecutive ranges, [first,middle) and [middle,last), and puts the result in [first,last). The output will be sorted. The sort is stable, that is, for equivalent elements in the two ranges, elements from the first range will always come before elements from the second.

If enough additional memory is available, this takes (last-first)-1 comparisons. Otherwise an NlogN algorithm is used, where N is distance(first,last).

The comparison function should have the same effects on ordering as the function used for the initial sort.

Definition at line 3508 of file stl_algo.h.

References distance().

void std::inplace_merge | ( | _BidirectionalIterator | __first,
|  | _BidirectionalIterator | __middle,
|  | _BidirectionalIterator | __last
| ) |

Merges two sorted ranges in place.

Parameters:

  | first | An iterator.
  | middle | Another iterator.
  | last | Another iterator.

Returns:
  Nothing.

Merges two sorted and consecutive ranges, [first,middle) and [middle,last), and puts the result in [first,last). The output will be sorted. The sort is stable, that is, for equivalent elements in the two ranges, elements from the first range will always come before elements from the second.

If enough additional memory is available, this takes (last-first)-1 comparisons. Otherwise an NlogN algorithm is used, where N is distance(first,last).

Definition at line 3454 of file stl_algo.h.

References distance().

insert_iterator<_Container> std::inserter | ( | _Container & | __x,
|  | _Iterator | __i
| ) | `[inline]`

Parameters:

  | x | A container of arbitrary type.

Returns:
  An instance of insert_iterator working on `x`.

This wrapper function helps in creating insert_iterator instances. Typing the name of the iterator requires knowing the precise full type of the container, which can be tedious and impedes generic programming. Using this function lets you take advantage of automatic template parameter deduction, making the compiler match the correct types for you.

Definition at line 567 of file stl_iterator.h.

ios_base& std::internal | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::internal, ios_base::adjustfield). Definition at line 901 of file ios_base.h. References ios_base::adjustfield, and ios_base::internal.

bool isalnum | ( | _CharT | __c,
|  | const locale & | __loc
| ) | `[inline]`

| Convenience interface to ctype.is(ctype_base::alnum, __c). Definition at line 4556 of file locale_facets.h.

bool isalpha | ( | _CharT | __c,
|  | const locale & | __loc
| ) | `[inline]`

| Convenience interface to ctype.is(ctype_base::alpha, __c). Definition at line 4532 of file locale_facets.h.

bool iscntrl | ( | _CharT | __c,
|  | const locale & | __loc
| ) | `[inline]`

| Convenience interface to ctype.is(ctype_base::cntrl, __c). Definition at line 4514 of file locale_facets.h.

bool isdigit | ( | _CharT | __c,
|  | const locale & | __loc
| ) | `[inline]`

| Convenience interface to ctype.is(ctype_base::digit, __c). Definition at line 4538 of file locale_facets.h.

bool isgraph | ( | _CharT | __c,
|  | const locale & | __loc
| ) | `[inline]`

| Convenience interface to ctype.is(ctype_base::graph, __c). Definition at line 4562 of file locale_facets.h.

bool islower | ( | _CharT | __c,
|  | const locale & | __loc
| ) | `[inline]`

| Convenience interface to ctype.is(ctype_base::lower, __c). Definition at line 4526 of file locale_facets.h.

bool isprint | ( | _CharT | __c,
|  | const locale & | __loc
| ) | `[inline]`

| Convenience interface to ctype.is(ctype_base::print, __c). Definition at line 4508 of file locale_facets.h.

bool ispunct | ( | _CharT | __c,
|  | const locale & | __loc
| ) | `[inline]`

| Convenience interface to ctype.is(ctype_base::punct, __c). Definition at line 4544 of file locale_facets.h.

bool isspace | ( | _CharT | __c,
|  | const locale & | __loc
| ) | `[inline]`

| Convenience interface to ctype.is(ctype_base::space, __c). Definition at line 4502 of file locale_facets.h.

bool isupper | ( | _CharT | __c,
|  | const locale & | __loc
| ) | `[inline]`

| Convenience interface to ctype.is(ctype_base::upper, __c). Definition at line 4520 of file locale_facets.h.

bool isxdigit | ( | _CharT | __c,
|  | const locale & | __loc
| ) | `[inline]`

| Convenience interface to ctype.is(ctype_base::xdigit, __c). Definition at line 4550 of file locale_facets.h.

void std::iter_swap | ( | _ForwardIterator1 | __a,
|  | _ForwardIterator2 | __b
| ) | `[inline]`

Swaps the contents of two iterators.

Parameters:

  | a | An iterator.
  | b | Another iterator.

Returns:
  Nothing.

This function swaps the values pointed to by two iterators, not the iterators themselves.

Definition at line 142 of file stl_algobase.h.

Referenced by next_permutation(), prev_permutation(), random_shuffle(), and swap_ranges().

ios_base& std::left | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::left, ios_base::adjustfield). Definition at line 909 of file ios_base.h. References ios_base::adjustfield, and ios_base::left.

bool std::lexicographical_compare | ( | _InputIterator1 | __first1,
|  | _InputIterator1 | __last1,
|  | _InputIterator2 | __first2,
|  | _InputIterator2 | __last2,
|  | _Compare | __comp
| ) |

Performs "dictionary" comparison on ranges.

Parameters:

  | first1 | An input iterator.
  | last1 | An input iterator.
  | first2 | An input iterator.
  | last2 | An input iterator.
  | comp | A comparison functor.

Returns:
  A boolean true or false.

The same as the four-parameter `lexigraphical_compare`, but uses the comp parameter instead of `<`.

Definition at line 853 of file stl_algobase.h.

bool std::lexicographical_compare | ( | _InputIterator1 | __first1,
|  | _InputIterator1 | __last1,
|  | _InputIterator2 | __first2,
|  | _InputIterator2 | __last2
| ) |

Performs "dictionary" comparison on ranges.

Parameters:

  | first1 | An input iterator.
  | last1 | An input iterator.
  | first2 | An input iterator.
  | last2 | An input iterator.

Returns:
  A boolean true or false.

"Returns true if the sequence of elements defined by the range [first1,last1) is lexicographically less than the sequence of elements defined by the range [first2,last2). Returns false otherwise." (Quoted from [25.3.8]/1.) If the iterators are all character pointers, then this is an inline call to `memcmp`.

Definition at line 812 of file stl_algobase.h.

Referenced by operator<().

void std::make_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last,
|  | _Compare | __comp
| ) | `[inline]`

Construct a heap over a range using comparison functor.

Parameters:

  | first | Start of heap.
  | last | End of heap.
  | comp | Comparison functor to use.

This operation makes the elements in [first,last) into a heap. Comparisons are made using comp.

Definition at line 384 of file stl_heap.h.

void std::make_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last
| ) |

Construct a heap over a range.

Parameters:

  | first | Start of heap.
  | last | End of heap.

This operation makes the elements in [first,last) into a heap.

Definition at line 344 of file stl_heap.h.

Referenced by partial_sort(), partial_sort_copy(), and priority_queue::priority_queue().

pair<_T1, _T2> std::make_pair | ( | _T1 | __x,
|  | _T2 | __y
| ) | `[inline]`

A convenience wrapper for creating a pair from two objects.

Parameters:

  | x | The first object.
  | y | The second object.

Returns:
  A newly-constructed pair<> object of the appropriate type.

The standard requires that the objects be passed by reference-to-const, but LWG issue #181 says they should be passed by const value. We follow the LWG by default.

Definition at line 144 of file stl_pair.h.

const _Tp& std::max | ( | const _Tp & | __a,
|  | const _Tp & | __b,
|  | _Compare | __comp
| ) | `[inline]`

This does what you think it does.

Parameters:

  | a | A thing of arbitrary type.
  | b | Another thing of arbitrary type.
  | comp | A comparison functor.

Returns:
  The greater of the parameters.

This will work on temporary expressions, since they are only evaluated once, unlike a preprocessor macro.

Definition at line 248 of file stl_algobase.h.

const _Tp& std::max | ( | const _Tp & | __a,
|  | const _Tp & | __b
| ) | `[inline]`

This does what you think it does.

Parameters:

  | a | A thing of arbitrary type.
  | b | Another thing of arbitrary type.

Returns:
  The greater of the parameters.

This is the simple classic generic implementation. It will work on temporary expressions, since they are only evaluated once, unlike a preprocessor macro.

Definition at line 206 of file stl_algobase.h.

Referenced by basic_istream::ignore(), operator>>(), basic_istream::operator>>(), and basic_stringbuf::overflow().

_ForwardIterator std::max_element | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | _Compare | __comp
| ) |

Return the maximum element in a range using comparison functor.

Parameters:

  | first | Start of range.
  | last | End of range.
  | comp | Comparison functor.

Returns:
  Iterator referencing the first instance of the largest value according to comp.

Definition at line 4569 of file stl_algo.h.

_ForwardIterator std::max_element | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last
| ) |

Return the maximum element in a range.

Parameters:

  | first | Start of range.
  | last | End of range.

Returns:
  Iterator referencing the first instance of the largest value.

Definition at line 4542 of file stl_algo.h.

Referenced by valarray::max().

_OutputIterator std::merge | ( | _InputIterator1 | __first1,
|  | _InputIterator1 | __last1,
|  | _InputIterator2 | __first2,
|  | _InputIterator2 | __last2,
|  | _OutputIterator | __result,
|  | _Compare | __comp
| ) |

Merges two sorted ranges.

Parameters:

  | first1 | An iterator.
  | first2 | Another iterator.
  | last1 | Another iterator.
  | last2 | Another iterator.
  | result | An iterator pointing to the end of the merged range.
  | comp | A functor to use for comparisons.

Returns:
  An iterator pointing to the first element "not less than" val.

Merges the ranges [first1,last1) and [first2,last2) into the sorted range [result, result + (last1-first1) + (last2-first2)). Both input ranges must be sorted, and the output range must not overlap with either of the input ranges. The sort is stable, that is, for equivalent elements in the two ranges, elements from the first range will always come before elements from the second.

The comparison function should have the same effects on ordering as the function used for the initial sort.

Definition at line 3035 of file stl_algo.h.

References copy().

_OutputIterator std::merge | ( | _InputIterator1 | __first1,
|  | _InputIterator1 | __last1,
|  | _InputIterator2 | __first2,
|  | _InputIterator2 | __last2,
|  | _OutputIterator | __result
| ) |

Merges two sorted ranges.

Parameters:

  | first1 | An iterator.
  | first2 | Another iterator.
  | last1 | Another iterator.
  | last2 | Another iterator.
  | result | An iterator pointing to the end of the merged range.

Returns:
  An iterator pointing to the first element "not less than" val.

Merges the ranges [first1,last1) and [first2,last2) into the sorted range [result, result + (last1-first1) + (last2-first2)). Both input ranges must be sorted, and the output range must not overlap with either of the input ranges. The sort is stable, that is, for equivalent elements in the two ranges, elements from the first range will always come before elements from the second.

Definition at line 2977 of file stl_algo.h.

References copy().

const _Tp& std::min | ( | const _Tp & | __a,
|  | const _Tp & | __b,
|  | _Compare | __comp
| ) | `[inline]`

This does what you think it does.

Parameters:

  | a | A thing of arbitrary type.
  | b | Another thing of arbitrary type.
  | comp | A comparison functor.

Returns:
  The lesser of the parameters.

This will work on temporary expressions, since they are only evaluated once, unlike a preprocessor macro.

Definition at line 228 of file stl_algobase.h.

const _Tp& std::min | ( | const _Tp & | __a,
|  | const _Tp & | __b
| ) | `[inline]`

This does what you think it does.

Parameters:

  | a | A thing of arbitrary type.
  | b | Another thing of arbitrary type.

Returns:
  The lesser of the parameters.

This is the simple classic generic implementation. It will work on temporary expressions, since they are only evaluated once, unlike a preprocessor macro.

Definition at line 184 of file stl_algobase.h.

Referenced by basic_string::compare(), basic_string< char >::compare(), basic_istream::ignore(), basic_istream::operator>>(), basic_stringbuf::overflow(), __gnu_cxx::random_sample_n(), basic_istream::readsome(), basic_string::rfind(), basic_filebuf::underflow(), basic_streambuf::xsgetn(), and basic_streambuf::xsputn().

_ForwardIterator std::min_element | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | _Compare | __comp
| ) |

Return the minimum element in a range using comparison functor.

Parameters:

  | first | Start of range.
  | last | End of range.
  | comp | Comparison functor.

Returns:
  Iterator referencing the first instance of the smallest value according to comp.

Definition at line 4621 of file stl_algo.h.

_ForwardIterator std::min_element | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last
| ) |

Return the minimum element in a range.

Parameters:

  | first | Start of range.
  | last | End of range.

Returns:
  Iterator referencing the first instance of the smallest value.

Definition at line 4594 of file stl_algo.h.

Referenced by valarray::min().

pair<_InputIterator1, _InputIterator2> std::mismatch | ( | _InputIterator1 | __first1,
|  | _InputIterator1 | __last1,
|  | _InputIterator2 | __first2,
|  | _BinaryPredicate | __binary_pred
| ) |

Finds the places in ranges which don't match.

Parameters:

  | first1 | An input iterator.
  | last1 | An input iterator.
  | first2 | An input iterator.
  | binary_pred | A binary predicate functor.

Returns:
  A pair of iterators pointing to the first mismatch.

This compares the elements of two ranges using the binary_pred parameter, and returns a pair of iterators. The first iterator points into the first range, the second iterator points into the second range, and the elements pointed to by the iterators are not equal.

Definition at line 719 of file stl_algobase.h.

pair<_InputIterator1, _InputIterator2> std::mismatch | ( | _InputIterator1 | __first1,
|  | _InputIterator1 | __last1,
|  | _InputIterator2 | __first2
| ) |

Finds the places in ranges which don't match.

Parameters:

  | first1 | An input iterator.
  | last1 | An input iterator.
  | first2 | An input iterator.

Returns:
  A pair of iterators pointing to the first mismatch.

This compares the elements of two ranges using `==` and returns a pair of iterators. The first iterator points into the first range, the second iterator points into the second range, and the elements pointed to by the iterators are not equal.

Definition at line 683 of file stl_algobase.h.

bool std::next_permutation | ( | _BidirectionalIterator | __first,
|  | _BidirectionalIterator | __last,
|  | _Compare | __comp
| ) |

Permute range into the next "dictionary" ordering using comparison functor.

Parameters:

  | first | Start of range.
  | last | End of range.
  | comp |

Returns:
  False if wrapped to first permutation, true otherwise.

Treats all permutations of the range [first,last) as a set of "dictionary" sorted sequences ordered by comp. Permutes the current sequence into the next one of this set. Returns true if there are more sequences to generate. If the sequence is the largest of the set, the smallest is generated and false returned.

Definition at line 4712 of file stl_algo.h.

References iter_swap(), and reverse().

bool std::next_permutation | ( | _BidirectionalIterator | __first,
|  | _BidirectionalIterator | __last
| ) |

Permute range into the next "dictionary" ordering.

Parameters:

  | first | Start of range.
  | last | End of range.

Returns:
  False if wrapped to first permutation, true otherwise.

Treats all permutations of the range as a set of "dictionary" sorted sequences. Permutes the current sequence into the next one of this set. Returns true if there are more sequences to generate. If the sequence is the largest of the set, the smallest is generated and false returned.

Definition at line 4656 of file stl_algo.h.

References iter_swap(), and reverse().

ios_base& std::noboolalpha | ( | ios_base & | __base | ) | `[inline]`

| Calls base.unsetf(ios_base::boolalpha). Definition at line 796 of file ios_base.h. References ios_base::boolalpha.

ios_base& std::noshowbase | ( | ios_base & | __base | ) | `[inline]`

| Calls base.unsetf(ios_base::showbase). Definition at line 812 of file ios_base.h. References ios_base::showbase.

ios_base& std::noshowpoint | ( | ios_base & | __base | ) | `[inline]`

| Calls base.unsetf(ios_base::showpoint). Definition at line 828 of file ios_base.h. References ios_base::showpoint.

ios_base& std::noshowpos | ( | ios_base & | __base | ) | `[inline]`

| Calls base.unsetf(ios_base::showpos). Definition at line 844 of file ios_base.h. References ios_base::showpos.

ios_base& std::noskipws | ( | ios_base & | __base | ) | `[inline]`

| Calls base.unsetf(ios_base::skipws). Definition at line 860 of file ios_base.h. References ios_base::skipws.

ios_base& std::nounitbuf | ( | ios_base & | __base | ) | `[inline]`

| Calls base.unsetf(ios_base::unitbuf). Definition at line 892 of file ios_base.h. References ios_base::unitbuf.

ios_base& std::nouppercase | ( | ios_base & | __base | ) | `[inline]`

| Calls base.unsetf(ios_base::uppercase). Definition at line 876 of file ios_base.h. References ios_base::uppercase.

void std::nth_element | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __nth,
|  | _RandomAccessIterator | __last,
|  | _Compare | __comp
| ) |

Sort a sequence just enough to find a particular position using a predicate for comparison.

Parameters:

  | first | An iterator.
  | nth | Another iterator.
  | last | Another iterator.
  | comp | A comparison functor.

Returns:
  Nothing.

Rearranges the elements in the range ``[first,last) so that `*nth` is the same element that would have been in that position had the whole sequence been sorted. The elements either side of `*nth` are not completely sorted, but for any iterator in the range ``[first,nth) and any iterator in the range ``[nth,last) it holds that `comp(*j,*i)` is false.

Definition at line 3750 of file stl_algo.h.

References __median().

void std::nth_element | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __nth,
|  | _RandomAccessIterator | __last
| ) |

Sort a sequence just enough to find a particular position.

Parameters:

  | first | An iterator.
  | nth | Another iterator.
  | last | Another iterator.

Returns:
  Nothing.

Rearranges the elements in the range ``[first,last) so that `*nth` is the same element that would have been in that position had the whole sequence been sorted. whole sequence been sorted. The elements either side of `*nth` are not completely sorted, but for any iterator in the range ``[first,nth) and any iterator in the range ``[nth,last) it holds that `*j<*i` is false.

Definition at line 3699 of file stl_algo.h.

References __median().

ios_base& std::oct | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::oct, ios_base::basefield). Definition at line 942 of file ios_base.h. References ios_base::basefield, and ios_base::oct.

bitset<_Nb> std::operator & | ( | const bitset< _Nb > & | __x,
|  | const bitset< _Nb > & | __y
| ) | `[inline]`

Global bitwise operations on bitsets.

Parameters:

  | x | A bitset.
  | y | A bitset of the same size as x.

Returns:
  A new bitset.

These should be self-explanatory.

Definition at line 1183 of file bitset.

bool std::operator!= | ( | const istream_iterator< _Tp, _CharT, _Traits, _Dist > & | __x,
|  | const istream_iterator< _Tp, _CharT, _Traits, _Dist > & | __y
| ) | `[inline]`

| Return false if x and y are both end or not end, or x and y are the same. Definition at line 135 of file stream_iterator.h.

bool std::operator!= | ( | const vector< _Tp, _Alloc > & | __x,
|  | const vector< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator==. Definition at line 952 of file stl_vector.h.

bool std::operator!= | ( | const stack< _Tp, _Seq > & | __x,
|  | const stack< _Tp, _Seq > & | __y
| ) | `[inline]`

| Based on operator==. Definition at line 250 of file stl_stack.h.

bool std::operator!= | ( | const set< _Key, _Compare, _Alloc > & | __x,
|  | const set< _Key, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Returns !(x == y). Definition at line 560 of file stl_set.h.

bool std::operator!= | ( | const queue< _Tp, _Sequence > & | __x,
|  | const queue< _Tp, _Sequence > & | __y
| ) | `[inline]`

| Based on operator==. Definition at line 275 of file stl_queue.h.

bool std::operator!= | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) | `[inline]`

| Uses `operator==` to find the result. Definition at line 109 of file stl_pair.h.

bool std::operator!= | ( | const multiset< _Key, _Compare, _Alloc > & | __x,
|  | const multiset< _Key, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Returns !(x == y). Definition at line 551 of file stl_multiset.h.

bool std::operator!= | ( | const multimap< _Key, _Tp, _Compare, _Alloc > & | __x,
|  | const multimap< _Key, _Tp, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Based on operator==. Definition at line 644 of file stl_multimap.h.

bool std::operator!= | ( | const map< _Key, _Tp, _Compare, _Alloc > & | __x,
|  | const map< _Key, _Tp, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Based on operator==. Definition at line 662 of file stl_map.h.

bool std::operator!= | ( | const list< _Tp, _Alloc > & | __x,
|  | const list< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator==. Definition at line 1214 of file stl_list.h.

bool std::operator!= | ( | const deque< _Tp, _Alloc > & | __x,
|  | const deque< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator==. Definition at line 1498 of file stl_deque.h.

bool std::operator!= | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | const _CharT * | __rhs
| ) | `[inline]`

Test difference of string and C string.

Parameters:

  | lhs | String.
  | rhs | C string.

Returns:
  True if lhs.compare(rhs) != 0. False otherwise.

Definition at line 2189 of file basic_string.h.

bool std::operator!= | ( | const _CharT * | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) | `[inline]`

Test difference of C string and string.

Parameters:

  | lhs | C string.
  | rhs | String.

Returns:
  True if rhs.compare(lhs) != 0. False otherwise.

Definition at line 2177 of file basic_string.h.

References basic_string::compare().

bool std::operator!= | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) | `[inline]`

Test difference of two strings.

Parameters:

  | lhs | First string.
  | rhs | Second string.

Returns:
  True if lhs.compare(rhs) != 0. False otherwise.

Definition at line 2165 of file basic_string.h.

References basic_string::compare().

basic_string<_CharT, _Traits, _Alloc> std::operator+ | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | _CharT | __rhs
| ) | `[inline]`

Concatenate string and character.

Parameters:

  | lhs | First string.
  | rhs | Last string.

Returns:
  New string with lhs followed by rhs.

Definition at line 2110 of file basic_string.h.

basic_string<_CharT, _Traits, _Alloc> std::operator+ | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | const _CharT * | __rhs
| ) | `[inline]`

Concatenate string and C string.

Parameters:

  | lhs | First string.
  | rhs | Last string.

Returns:
  New string with lhs followed by rhs.

Definition at line 2094 of file basic_string.h.

References basic_string::append().

basic_string< _CharT, _Traits, _Alloc > operator+ | ( | _CharT | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) |

Concatenate character and string.

Parameters:

  | lhs | First string.
  | rhs | Last string.

Returns:
  New string with lhs followed by rhs.

Definition at line 681 of file basic_string.tcc.

References basic_string::size().

basic_string< _CharT, _Traits, _Alloc > operator+ | ( | const _CharT * | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) |

Concatenate C string and string.

Parameters:

  | lhs | First string.
  | rhs | Last string.

Returns:
  New string with value of lhs followed by rhs.

Definition at line 665 of file basic_string.tcc.

References basic_string::size().

basic_string<_CharT, _Traits, _Alloc> std::operator+ | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) |

Concatenate two strings.

Parameters:

  | lhs | First string.
  | rhs | Last string.

Returns:
  New string with value of lhs followed by rhs.

Definition at line 2057 of file basic_string.h.

References basic_string::append().

bool std::operator< | ( | const vector< _Tp, _Alloc > & | __x,
|  | const vector< _Tp, _Alloc > & | __y
| ) | `[inline]`

Vector ordering relation.

Parameters:

  | x | A vector.
  | y | A vector of the same type as x.

Returns:
  True iff x is lexicographically less than y.

This is a total ordering relation. It is linear in the size of the vectors. The elements must be comparable with `<`.

See std::lexicographical_compare() for how the determination is made.

Definition at line 945 of file stl_vector.h.

References lexicographical_compare().

bool operator< | ( | const stack< _Tp, _Seq > & | __x,
|  | const stack< _Tp, _Seq > & | __y
| ) | `[inline]`

Stack ordering relation.

Parameters:

  | x | A stack.
  | y | A stack of the same type as x.

Returns:
  True iff x is lexicographically less than y.

This is an total ordering relation. Complexity and semantics depend on the underlying sequence type, but the expected rules are: this relation is linear in the size of the sequences, the elements must be comparable with `<`, and std::lexicographical_compare() is usually used to make the determination.

Definition at line 244 of file stl_stack.h.

bool operator< | ( | const set< _Key, _Compare, _Alloc > & | __x,
|  | const set< _Key, _Compare, _Alloc > & | __y
| ) | `[inline]`

Set ordering relation.

Parameters:

  | x | A set.
  | y | A set of the same type as x.

Returns:
  True iff x is lexicographically less than y.

This is a total ordering relation. It is linear in the size of the maps. The elements must be comparable with `<`.

See std::lexicographical_compare() for how the determination is made.

Definition at line 553 of file stl_set.h.

bool std::operator< | ( | const queue< _Tp, _Sequence > & | __x,
|  | const queue< _Tp, _Sequence > & | __y
| ) | `[inline]`

Queue ordering relation.

Parameters:

  | x | A queue.
  | y | A queue of the same type as x.

Returns:
  True iff x is lexicographically less than y.

This is an total ordering relation. Complexity and semantics depend on the underlying sequence type, but the expected rules are: this relation is linear in the size of the sequences, the elements must be comparable with `<`, and std::lexicographical_compare() is usually used to make the determination.

Definition at line 269 of file stl_queue.h.

bool std::operator< | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) | `[inline]`

| <http://gcc.gnu.org/onlinedocs/libstdc++/20_util/howto.html#pairlt> Definition at line 102 of file stl_pair.h.

bool operator< | ( | const multiset< _Key, _Compare, _Alloc > & | __x,
|  | const multiset< _Key, _Compare, _Alloc > & | __y
| ) | `[inline]`

Multiset ordering relation.

Parameters:

  | x | A multiset.
  | y | A multiset of the same type as x.

Returns:
  True iff x is lexicographically less than y.

This is a total ordering relation. It is linear in the size of the maps. The elements must be comparable with `<`.

See std::lexicographical_compare() for how the determination is made.

Definition at line 544 of file stl_multiset.h.

bool operator< | ( | const multimap< _Key, _Tp, _Compare, _Alloc > & | __x,
|  | const multimap< _Key, _Tp, _Compare, _Alloc > & | __y
| ) | `[inline]`

Multimap ordering relation.

Parameters:

  | x | A multimap.
  | y | A multimap of the same type as x.

Returns:
  True iff x is lexicographically less than y.

This is a total ordering relation. It is linear in the size of the multimaps. The elements must be comparable with `<`.

See std::lexicographical_compare() for how the determination is made.

Definition at line 637 of file stl_multimap.h.

bool std::operator< | ( | const map< _Key, _Tp, _Compare, _Alloc > & | __x,
|  | const map< _Key, _Tp, _Compare, _Alloc > & | __y
| ) | `[inline]`

Map ordering relation.

Parameters:

  | x | A map.
  | y | A map of the same type as x.

Returns:
  True iff x is lexicographically less than y.

This is a total ordering relation. It is linear in the size of the maps. The elements must be comparable with `<`.

See std::lexicographical_compare() for how the determination is made.

Definition at line 655 of file stl_map.h.

bool std::operator< | ( | const list< _Tp, _Alloc > & | __x,
|  | const list< _Tp, _Alloc > & | __y
| ) | `[inline]`

List ordering relation.

Parameters:

  | x | A list.
  | y | A list of the same type as x.

Returns:
  True iff x is lexicographically less than y.

This is a total ordering relation. It is linear in the size of the lists. The elements must be comparable with `<`.

See std::lexicographical_compare() for how the determination is made.

Definition at line 1207 of file stl_list.h.

References lexicographical_compare().

bool std::operator< | ( | const deque< _Tp, _Alloc > & | __x,
|  | const deque< _Tp, _Alloc > & | __y
| ) | `[inline]`

Deque ordering relation.

Parameters:

  | x | A deque.
  | y | A deque of the same type as x.

Returns:
  True iff x is lexicographically less than y.

This is a total ordering relation. It is linear in the size of the deques. The elements must be comparable with `<`.

See std::lexicographical_compare() for how the determination is made.

Definition at line 1490 of file stl_deque.h.

References lexicographical_compare().

bool std::operator< | ( | const _CharT * | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) | `[inline]`

Test if C string precedes string.

Parameters:

  | lhs | C string.
  | rhs | String.

Returns:
  True if lhs precedes rhs. False otherwise.

Definition at line 2226 of file basic_string.h.

References basic_string::compare().

bool std::operator< | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | const _CharT * | __rhs
| ) | `[inline]`

Test if string precedes C string.

Parameters:

  | lhs | String.
  | rhs | C string.

Returns:
  True if lhs precedes rhs. False otherwise.

Definition at line 2214 of file basic_string.h.

bool std::operator< | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) | `[inline]`

Test if string precedes string.

Parameters:

  | lhs | First string.
  | rhs | Second string.

Returns:
  True if lhs precedes rhs. False otherwise.

Definition at line 2202 of file basic_string.h.

basic_ostream< _CharT, _Traits > & operator<< | ( | basic_ostream< _CharT, _Traits > & | __out,
|  | const _CharT * | __s
| ) |

String inserters.

Parameters:

  | out | An output stream.
  | s | A character string.

Returns:
  out

Precondition:
  s must be a non-NULL pointer

Behaves like one of the formatted arithmetic inserters described in std::basic_ostream. After constructing a sentry object with good status, this function inserts `traits::length(s)` characters starting at s, widened if necessary, followed by any required padding (as determined by [22.2.2.2.2]). `out.width(0)` is then called.

Definition at line 538 of file ostream.tcc.

References ios_base::badbit.

basic_ostream< _CharT, _Traits > & operator<< | ( | basic_ostream< _CharT, _Traits > & | __out,
|  | _CharT | __c
| ) |

Character inserters.

Parameters:

  | out | An output stream.
  | c | A character.

Returns:
  out

Behaves like one of the formatted arithmetic inserters described in std::basic_ostream. After constructing a sentry object with good status, this function inserts a single character and any required padding (as determined by [22.2.2.2.2]). `out.width(0)` is then called.

If c is of type `char` and the character type of the stream is not `char`, the character is widened before insertion.

Definition at line 478 of file ostream.tcc.

References ios_base::badbit.

basic_ostream< _CharT, _Traits > & operator<< | ( | basic_ostream< _CharT, _Traits > & | __os,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str
| ) |

Write string to a stream.

Parameters:

  | os | Output stream.
  | str | String to write out.

Returns:
  Reference to the output stream.

Output characters of str into os following the same rules as for writing a C string.

Definition at line 648 of file ostream.tcc.

bool std::operator<= | ( | const vector< _Tp, _Alloc > & | __x,
|  | const vector< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 964 of file stl_vector.h.

bool std::operator<= | ( | const stack< _Tp, _Seq > & | __x,
|  | const stack< _Tp, _Seq > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 262 of file stl_stack.h.

bool std::operator<= | ( | const set< _Key, _Compare, _Alloc > & | __x,
|  | const set< _Key, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Returns !(y < x). Definition at line 574 of file stl_set.h.

bool std::operator<= | ( | const queue< _Tp, _Sequence > & | __x,
|  | const queue< _Tp, _Sequence > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 288 of file stl_queue.h.

bool std::operator<= | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) | `[inline]`

| Uses `operator<` to find the result. Definition at line 121 of file stl_pair.h.

bool std::operator<= | ( | const multiset< _Key, _Compare, _Alloc > & | __x,
|  | const multiset< _Key, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Returns !(y < x). Definition at line 565 of file stl_multiset.h.

bool std::operator<= | ( | const multimap< _Key, _Tp, _Compare, _Alloc > & | __x,
|  | const multimap< _Key, _Tp, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 658 of file stl_multimap.h.

bool std::operator<= | ( | const map< _Key, _Tp, _Compare, _Alloc > & | __x,
|  | const map< _Key, _Tp, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 676 of file stl_map.h.

bool std::operator<= | ( | const list< _Tp, _Alloc > & | __x,
|  | const list< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 1226 of file stl_list.h.

bool std::operator<= | ( | const deque< _Tp, _Alloc > & | __x,
|  | const deque< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 1512 of file stl_deque.h.

bool std::operator<= | ( | const _CharT * | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) | `[inline]`

Test if C string doesn't follow string.

Parameters:

  | lhs | C string.
  | rhs | String.

Returns:
  True if lhs doesn't follow rhs. False otherwise.

Definition at line 2300 of file basic_string.h.

References basic_string::compare().

bool std::operator<= | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | const _CharT * | __rhs
| ) | `[inline]`

Test if string doesn't follow C string.

Parameters:

  | lhs | String.
  | rhs | C string.

Returns:
  True if lhs doesn't follow rhs. False otherwise.

Definition at line 2288 of file basic_string.h.

bool std::operator<= | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) | `[inline]`

Test if string doesn't follow string.

Parameters:

  | lhs | First string.
  | rhs | Second string.

Returns:
  True if lhs doesn't follow rhs. False otherwise.

Definition at line 2276 of file basic_string.h.

bool std::operator== | ( | const istream_iterator< _Tp, _CharT, _Traits, _Dist > & | __x,
|  | const istream_iterator< _Tp, _CharT, _Traits, _Dist > & | __y
| ) | `[inline]`

| Return true if x and y are both end or not end, or x and y are the same. Definition at line 128 of file stream_iterator.h.

bool std::operator== | ( | const vector< _Tp, _Alloc > & | __x,
|  | const vector< _Tp, _Alloc > & | __y
| ) | `[inline]`

Vector equality comparison.

Parameters:

  | x | A vector.
  | y | A vector of the same type as x.

Returns:
  True iff the size and elements of the vectors are equal.

This is an equivalence relation. It is linear in the size of the vectors. Vectors are considered equivalent if their sizes are equal, and if corresponding elements compare equal.

Definition at line 928 of file stl_vector.h.

References vector::begin(), vector::end(), equal(), and vector::size().

bool operator== | ( | const stack< _Tp, _Seq > & | __x,
|  | const stack< _Tp, _Seq > & | __y
| ) | `[inline]`

Stack equality comparison.

Parameters:

  | x | A stack.
  | y | A stack of the same type as x.

Returns:
  True iff the size and elements of the stacks are equal.

This is an equivalence relation. Complexity and semantics depend on the underlying sequence type, but the expected rules are: this relation is linear in the size of the sequences, and stacks are considered equivalent if their sequences compare equal.

Definition at line 226 of file stl_stack.h.

References stack::c.

bool operator== | ( | const set< _Key, _Compare, _Alloc > & | __x,
|  | const set< _Key, _Compare, _Alloc > & | __y
| ) | `[inline]`

Set equality comparison.

Parameters:

  | x | A set.
  | y | A set of the same type as x.

Returns:
  True iff the size and elements of the sets are equal.

This is an equivalence relation. It is linear in the size of the sets. Sets are considered equivalent if their sizes are equal, and if corresponding elements compare equal.

Definition at line 536 of file stl_set.h.

References set::_M_t.

bool std::operator== | ( | const queue< _Tp, _Sequence > & | __x,
|  | const queue< _Tp, _Sequence > & | __y
| ) | `[inline]`

Queue equality comparison.

Parameters:

  | x | A queue.
  | y | A queue of the same type as x.

Returns:
  True iff the size and elements of the queues are equal.

This is an equivalence relation. Complexity and semantics depend on the underlying sequence type, but the expected rules are: this relation is linear in the size of the sequences, and queues are considered equivalent if their sequences compare equal.

Definition at line 250 of file stl_queue.h.

References queue::c.

bool std::operator== | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) | `[inline]`

| Two pairs of the same type are equal iff their members are equal. Definition at line 96 of file stl_pair.h. References pair::first, and pair::second.

bool operator== | ( | const multiset< _Key, _Compare, _Alloc > & | __x,
|  | const multiset< _Key, _Compare, _Alloc > & | __y
| ) | `[inline]`

Multiset equality comparison.

Parameters:

  | x | A multiset.
  | y | A multiset of the same type as x.

Returns:
  True iff the size and elements of the multisets are equal.

This is an equivalence relation. It is linear in the size of the multisets. Multisets are considered equivalent if their sizes are equal, and if corresponding elements compare equal.

Definition at line 527 of file stl_multiset.h.

References multiset::_M_t.

bool operator== | ( | const multimap< _Key, _Tp, _Compare, _Alloc > & | __x,
|  | const multimap< _Key, _Tp, _Compare, _Alloc > & | __y
| ) | `[inline]`

Multimap equality comparison.

Parameters:

  | x | A multimap.
  | y | A multimap of the same type as x.

Returns:
  True iff the size and elements of the maps are equal.

This is an equivalence relation. It is linear in the size of the multimaps. Multimaps are considered equivalent if their sizes are equal, and if corresponding elements compare equal.

Definition at line 620 of file stl_multimap.h.

References multimap::_M_t.

bool std::operator== | ( | const map< _Key, _Tp, _Compare, _Alloc > & | __x,
|  | const map< _Key, _Tp, _Compare, _Alloc > & | __y
| ) | `[inline]`

Map equality comparison.

Parameters:

  | x | A map.
  | y | A map of the same type as x.

Returns:
  True iff the size and elements of the maps are equal.

This is an equivalence relation. It is linear in the size of the maps. Maps are considered equivalent if their sizes are equal, and if corresponding elements compare equal.

Definition at line 638 of file stl_map.h.

References map::_M_t.

bool std::operator== | ( | const list< _Tp, _Alloc > & | __x,
|  | const list< _Tp, _Alloc > & | __y
| ) | `[inline]`

List equality comparison.

Parameters:

  | x | A list.
  | y | A list of the same type as x.

Returns:
  True iff the size and elements of the lists are equal.

This is an equivalence relation. It is linear in the size of the lists. Lists are considered equivalent if their sizes are equal, and if corresponding elements compare equal.

Definition at line 1178 of file stl_list.h.

References list::begin(), and list::end().

bool std::operator== | ( | const reverse_iterator< _Iterator > & | __x,
|  | const reverse_iterator< _Iterator > & | __y
| ) | `[inline]`

Parameters:

  | x | A reverse_iterator.
  | y | A reverse_iterator.

Returns:
  A simple bool.

Reverse iterators forward many operations to their underlying base() iterators. Others are implemented in terms of one another.

Definition at line 277 of file stl_iterator.h.

References reverse_iterator::base().

bool std::operator== | ( | const deque< _Tp, _Alloc > & | __x,
|  | const deque< _Tp, _Alloc > & | __y
| ) | `[inline]`

Deque equality comparison.

Parameters:

  | x | A deque.
  | y | A deque of the same type as x.

Returns:
  True iff the size and elements of the deques are equal.

This is an equivalence relation. It is linear in the size of the deques. Deques are considered equivalent if their sizes are equal, and if corresponding elements compare equal.

Definition at line 1472 of file stl_deque.h.

References deque::begin(), deque::end(), equal(), and deque::size().

bool std::operator== | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | const _CharT * | __rhs
| ) | `[inline]`

Test equivalence of string and C string.

Parameters:

  | lhs | String.
  | rhs | C string.

Returns:
  True if lhs.compare(rhs) == 0. False otherwise.

Definition at line 2152 of file basic_string.h.

bool std::operator== | ( | const _CharT * | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) | `[inline]`

Test equivalence of C string and string.

Parameters:

  | lhs | C string.
  | rhs | String.

Returns:
  True if rhs.compare(lhs) == 0. False otherwise.

Definition at line 2140 of file basic_string.h.

References basic_string::compare().

bool std::operator== | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) | `[inline]`

Test equivalence of two strings.

Parameters:

  | lhs | First string.
  | rhs | Second string.

Returns:
  True if lhs.compare(rhs) == 0. False otherwise.

Definition at line 2128 of file basic_string.h.

bool std::operator> | ( | const vector< _Tp, _Alloc > & | __x,
|  | const vector< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 958 of file stl_vector.h.

bool std::operator> | ( | const stack< _Tp, _Seq > & | __x,
|  | const stack< _Tp, _Seq > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 256 of file stl_stack.h.

bool std::operator> | ( | const set< _Key, _Compare, _Alloc > & | __x,
|  | const set< _Key, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Returns y < x. Definition at line 567 of file stl_set.h.

bool std::operator> | ( | const queue< _Tp, _Sequence > & | __x,
|  | const queue< _Tp, _Sequence > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 282 of file stl_queue.h.

bool std::operator> | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) | `[inline]`

| Uses `operator<` to find the result. Definition at line 115 of file stl_pair.h.

bool std::operator> | ( | const multiset< _Key, _Compare, _Alloc > & | __x,
|  | const multiset< _Key, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Returns y < x. Definition at line 558 of file stl_multiset.h.

bool std::operator> | ( | const multimap< _Key, _Tp, _Compare, _Alloc > & | __x,
|  | const multimap< _Key, _Tp, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 651 of file stl_multimap.h.

bool std::operator> | ( | const map< _Key, _Tp, _Compare, _Alloc > & | __x,
|  | const map< _Key, _Tp, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 669 of file stl_map.h.

bool std::operator> | ( | const list< _Tp, _Alloc > & | __x,
|  | const list< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 1220 of file stl_list.h.

bool std::operator> | ( | const deque< _Tp, _Alloc > & | __x,
|  | const deque< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 1505 of file stl_deque.h.

bool std::operator> | ( | const _CharT * | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) | `[inline]`

Test if C string follows string.

Parameters:

  | lhs | C string.
  | rhs | String.

Returns:
  True if lhs follows rhs. False otherwise.

Definition at line 2263 of file basic_string.h.

References basic_string::compare().

bool std::operator> | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | const _CharT * | __rhs
| ) | `[inline]`

Test if string follows C string.

Parameters:

  | lhs | String.
  | rhs | C string.

Returns:
  True if lhs follows rhs. False otherwise.

Definition at line 2251 of file basic_string.h.

bool std::operator> | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) | `[inline]`

Test if string follows string.

Parameters:

  | lhs | First string.
  | rhs | Second string.

Returns:
  True if lhs follows rhs. False otherwise.

Definition at line 2239 of file basic_string.h.

bool std::operator>= | ( | const vector< _Tp, _Alloc > & | __x,
|  | const vector< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 970 of file stl_vector.h.

bool std::operator>= | ( | const stack< _Tp, _Seq > & | __x,
|  | const stack< _Tp, _Seq > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 268 of file stl_stack.h.

bool std::operator>= | ( | const set< _Key, _Compare, _Alloc > & | __x,
|  | const set< _Key, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Returns !(x < y). Definition at line 581 of file stl_set.h.

bool std::operator>= | ( | const queue< _Tp, _Sequence > & | __x,
|  | const queue< _Tp, _Sequence > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 295 of file stl_queue.h.

bool std::operator>= | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) | `[inline]`

| Uses `operator<` to find the result. Definition at line 127 of file stl_pair.h.

bool std::operator>= | ( | const multiset< _Key, _Compare, _Alloc > & | __x,
|  | const multiset< _Key, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Returns !(x < y). Definition at line 572 of file stl_multiset.h.

bool std::operator>= | ( | const multimap< _Key, _Tp, _Compare, _Alloc > & | __x,
|  | const multimap< _Key, _Tp, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 665 of file stl_multimap.h.

bool std::operator>= | ( | const map< _Key, _Tp, _Compare, _Alloc > & | __x,
|  | const map< _Key, _Tp, _Compare, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 683 of file stl_map.h.

bool std::operator>= | ( | const list< _Tp, _Alloc > & | __x,
|  | const list< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 1232 of file stl_list.h.

bool std::operator>= | ( | const deque< _Tp, _Alloc > & | __x,
|  | const deque< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 1519 of file stl_deque.h.

bool std::operator>= | ( | const _CharT * | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) | `[inline]`

Test if C string doesn't precede string.

Parameters:

  | lhs | C string.
  | rhs | String.

Returns:
  True if lhs doesn't precede rhs. False otherwise.

Definition at line 2337 of file basic_string.h.

References basic_string::compare().

bool std::operator>= | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | const _CharT * | __rhs
| ) | `[inline]`

Test if string doesn't precede C string.

Parameters:

  | lhs | String.
  | rhs | C string.

Returns:
  True if lhs doesn't precede rhs. False otherwise.

Definition at line 2325 of file basic_string.h.

bool std::operator>= | ( | const basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) | `[inline]`

Test if string doesn't precede string.

Parameters:

  | lhs | First string.
  | rhs | Second string.

Returns:
  True if lhs doesn't precede rhs. False otherwise.

Definition at line 2313 of file basic_string.h.

basic_istream<_CharT, _Traits>& std::operator>> | ( | basic_istream< _CharT, _Traits > & | __is,
|  | bitset< _Nb > & | __x
| ) |

Global I/O operators for bitsets.

Direct I/O between streams and bitsets is supported. Output is straightforward. Input will skip whitespace, only accept '0' and '1' characters, and will only extract as many digits as the bitset will hold.

Definition at line 1220 of file bitset.

References bitset::_M_copy_from_string(), ios_base::badbit, basic_string::empty(), ios_base::eofbit, ios_base::failbit, ios_base::goodbit, basic_string::push_back(), basic_string::reserve(), basic_streambuf::sbumpc(), and basic_streambuf::sputbackc().

basic_istream< _CharT, _Traits > & operator>> | ( | basic_istream< _CharT, _Traits > & | __in,
|  | _CharT * | __s
| ) |

Character string extractors.

Parameters:

  | in | An input stream.
  | s | A pointer to a character array.

Returns:
  in

Behaves like one of the formatted arithmetic extractors described in std::basic_istream. After constructing a sentry object with good status, this function extracts up to `n` characters and stores them into the array starting at s. `n` is defined as:

- if `width()` is greater than zero, `n` is width()
- otherwise `n` is "the number of elements of the largest array of `char_type` that can store a terminating `eos`." [27.6.1.2.3]/6

Characters are extracted and stored until one of the following happens:

- `n-1` characters are stored
- EOF is reached
- the next character is whitespace according to the current locale
- the next character is a null byte (i.e., `charT()` )

`width(0)` is then called for the input stream.

If no characters are extracted, sets failbit.

Definition at line 1050 of file istream.tcc.

References ios_base::badbit, ios_base::eofbit, ios_base::failbit, ios_base::goodbit, and max().

basic_istream< _CharT, _Traits > & operator>> | ( | basic_istream< _CharT, _Traits > & | __in,
|  | _CharT & | __c
| ) |

Character extractors.

Parameters:

  | in | An input stream.
  | c | A character reference.

Returns:
  in

Behaves like one of the formatted arithmetic extractors described in std::basic_istream. After constructing a sentry object with good status, this function extracts a character (if one is available) and stores it in c. Otherwise, sets failbit in the input stream.

Definition at line 1023 of file istream.tcc.

References basic_ios::_M_setstate(), ios_base::badbit, ios_base::eofbit, ios_base::failbit, ios_base::goodbit, basic_ios::rdbuf(), and basic_ios::setstate().

basic_istream< _CharT, _Traits > & operator>> | ( | basic_istream< _CharT, _Traits > & | __is,
|  | basic_string< _CharT, _Traits, _Alloc > & | __str
| ) |

Read stream into a string.

Parameters:

  | is | Input stream.
  | str | Buffer to store into.

Returns:
  Reference to the input stream.

Stores characters from is into str until whitespace is found, the end of the stream is encountered, or str.max_size() is reached. If is.width() is non-zero, that is the limit on the number of characters stored into str. Any previous contents of str are erased.

Definition at line 1130 of file istream.tcc.

References basic_string::append(), ios_base::badbit, ios_base::eofbit, basic_string::erase(), ios_base::failbit, ios_base::goodbit, and basic_string::max_size().

void std::partial_sort | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __middle,
|  | _RandomAccessIterator | __last,
|  | _Compare | __comp
| ) |

Sort the smallest elements of a sequence using a predicate for comparison.

Parameters:

  | first | An iterator.
  | middle | Another iterator.
  | last | Another iterator.
  | comp | A comparison functor.

Returns:
  Nothing.

Sorts the smallest ``(middle-first) elements in the range ``[first,last) and moves them to the range ``[first,middle). The order of the remaining elements in the range ``[middle,last) is undefined. After the sort if `i` and are iterators in the range ``[first,middle) such that precedes and is an iterator in the range ``[middle,last) then `*comp`(j,*i) and `comp(*k,*i)` are both false.

Definition at line 2316 of file stl_algo.h.

References make_heap(), and sort_heap().

void std::partial_sort | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __middle,
|  | _RandomAccessIterator | __last
| ) |

Sort the smallest elements of a sequence.

Parameters:

  | first | An iterator.
  | middle | Another iterator.
  | last | Another iterator.

Returns:
  Nothing.

Sorts the smallest ``(middle-first) elements in the range ``[first,last) and moves them to the range ``[first,middle). The order of the remaining elements in the range ``[middle,last) is undefined. After the sort if `i` and are iterators in the range ``[first,middle) such that precedes and is an iterator in the range ``[middle,last) then `*j<*i` and `*k<*i` are both false.

Definition at line 2275 of file stl_algo.h.

References make_heap(), and sort_heap().

_RandomAccessIterator std::partial_sort_copy | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _RandomAccessIterator | __result_first,
|  | _RandomAccessIterator | __result_last,
|  | _Compare | __comp
| ) |

Copy the smallest elements of a sequence using a predicate for comparison.

Parameters:

  | first | An input iterator.
  | last | Another input iterator.
  | result_first | A random-access iterator.
  | result_last | Another random-access iterator.
  | comp | A comparison functor.

Returns:
  An iterator indicating the end of the resulting sequence.

Copies and sorts the smallest N values from the range ``[first,last) to the range beginning at `result_first`, where the number of elements to be copied, `N`, is the smaller of ``(last-first) and ``(result_last-result_first). After the sort if `i` and are iterators in the range ``[result_first,result_first+N) such that precedes then `comp(*j,*i)` is false. The value returned is `result_first+N`.

Definition at line 2422 of file stl_algo.h.

References make_heap(), and sort_heap().

_RandomAccessIterator std::partial_sort_copy | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _RandomAccessIterator | __result_first,
|  | _RandomAccessIterator | __result_last
| ) |

Copy the smallest elements of a sequence.

Parameters:

  | first | An iterator.
  | last | Another iterator.
  | result_first | A random-access iterator.
  | result_last | Another random-access iterator.

Returns:
  An iterator indicating the end of the resulting sequence.

Copies and sorts the smallest N values from the range ``[first,last) to the range beginning at `result_first`, where the number of elements to be copied, `N`, is the smaller of ``(last-first) and ``(result_last-result_first). After the sort if `i` and are iterators in the range ``[result_first,result_first+N) such that precedes then `*j<*i` is false. The value returned is `result_first+N`.

Definition at line 2358 of file stl_algo.h.

References make_heap(), and sort_heap().

_OutputIterator std::partial_sum | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _OutputIterator | __result,
|  | _BinaryOperation | __binary_op
| ) |

Return list of partial sums.

Accumulates the values in the range [first,last) using operator+(). As each successive input value is added into the total, that partial sum is written to result. Therefore, the first value in result is the first value of the input, the second value in result is the sum of the first and second input values, and so on.

Parameters:

  | first | Start of input range.
  | last | End of input range.
  | result | Output to write sums to.

Returns:
  Iterator pointing just beyond the values written to result.

Definition at line 239 of file stl_numeric.h.

_OutputIterator std::partial_sum | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _OutputIterator | __result
| ) |

Return list of partial sums.

Accumulates the values in the range [first,last) using operator+(). As each successive input value is added into the total, that partial sum is written to result. Therefore, the first value in result is the first value of the input, the second value in result is the sum of the first and second input values, and so on.

Parameters:

  | first | Start of input range.
  | last | End of input range.
  | result | Output to write sums to.

Returns:
  Iterator pointing just beyond the values written to result.

Definition at line 199 of file stl_numeric.h.

_ForwardIterator std::partition | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | _Predicate | __pred
| ) | `[inline]`

Move elements for which a predicate is true to the beginning of a sequence.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.
  | pred | A predicate functor.

Returns:
  An iterator `middle` such that `pred(i)` is true for each iterator `i` in the range ``[first,middle) and false for each `i` in the range ``[middle,last).

`pred` must not modify its operand. `partition()` does not preserve the relative ordering of elements in each group, use `stable_partition()` if this is needed.

Definition at line 1875 of file stl_algo.h.

void std::pop_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last,
|  | _Compare | __comp
| ) | `[inline]`

Pop an element off a heap using comparison functor.

Parameters:

  | first | Start of heap.
  | last | End of heap.
  | comp | Comparison functor to use.

This operation pops the top of the heap. The elements first and last-1 are swapped and [first,last-1) is made into a heap. Comparisons are made using comp.

Definition at line 319 of file stl_heap.h.

void std::pop_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last
| ) | `[inline]`

Pop an element off a heap.

Parameters:

  | first | Start of heap.
  | last | End of heap.

This operation pops the top of the heap. The elements first and last-1 are swapped and [first,last-1) is made into a heap.

Definition at line 253 of file stl_heap.h.

Referenced by priority_queue::pop(), and sort_heap().

bool std::prev_permutation | ( | _BidirectionalIterator | __first,
|  | _BidirectionalIterator | __last,
|  | _Compare | __comp
| ) |

Permute range into the previous "dictionary" ordering using comparison functor.

Parameters:

  | first | Start of range.
  | last | End of range.
  | comp |

Returns:
  False if wrapped to last permutation, true otherwise.

Treats all permutations of the range [first,last) as a set of "dictionary" sorted sequences ordered by comp. Permutes the current sequence into the previous one of this set. Returns true if there are more sequences to generate. If the sequence is the smallest of the set, the largest is generated and false returned.

Definition at line 4823 of file stl_algo.h.

References iter_swap(), and reverse().

bool std::prev_permutation | ( | _BidirectionalIterator | __first,
|  | _BidirectionalIterator | __last
| ) |

Permute range into the previous "dictionary" ordering.

Parameters:

  | first | Start of range.
  | last | End of range.

Returns:
  False if wrapped to last permutation, true otherwise.

Treats all permutations of the range as a set of "dictionary" sorted sequences. Permutes the current sequence into the previous one of this set. Returns true if there are more sequences to generate. If the sequence is the smallest of the set, the largest is generated and false returned.

Definition at line 4767 of file stl_algo.h.

References iter_swap(), and reverse().

void std::push_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last,
|  | _Compare | __comp
| ) | `[inline]`

Push an element onto a heap using comparison functor.

Parameters:

  | first | Start of heap.
  | last | End of heap + element.
  | comp | Comparison functor.

This operation pushes the element at last-1 onto the valid heap over the range [first,last-1). After completion, [first,last) is a valid heap. Compare operations are performed using comp.

Definition at line 189 of file stl_heap.h.

void std::push_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last
| ) | `[inline]`

Push an element onto a heap.

Parameters:

  | first | Start of heap.
  | last | End of heap + element.

This operation pushes the element at last-1 onto the valid heap over the range [first,last-1). After completion, [first,last) is a valid heap.

Definition at line 141 of file stl_heap.h.

Referenced by priority_queue::push().

void std::random_shuffle | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last,
|  | _RandomNumberGenerator & | __rand
| ) |

Shuffle the elements of a sequence using a random number generator.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.
  | rand | The RNG functor or function.

Returns:
  Nothing.

Reorders the elements in the range ``[first,last) using `rand` to provide a random distribution. Calling `rand(N)` for a positive integer `N` should return a randomly chosen integer from the range [0,N).

Definition at line 1781 of file stl_algo.h.

References iter_swap().

void std::random_shuffle | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last
| ) | `[inline]`

Randomly shuffle the elements of a sequence.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.

Returns:
  Nothing.

Reorder the elements in the range ``[first,last) using a random distribution, so that every possible ordering of the sequence is equally likely.

Definition at line 1754 of file stl_algo.h.

References iter_swap().

_ForwardIterator std::remove | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | const _Tp & | __value
| ) |

Remove elements from a sequence.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | value | The value to be removed.

Returns:
  An iterator designating the end of the resulting sequence.

All elements equal to `value` are removed from the range ``[first,last).

remove() is stable, so the relative order of elements that are not removed is unchanged.

Elements between the end of the resulting sequence and `last` are still present, but their value is unspecified.

Definition at line 1100 of file stl_algo.h.

References remove_copy().

_OutputIterator std::remove_copy | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _OutputIterator | __result,
|  | const _Tp & | __value
| ) |

Copy a sequence, removing elements of a given value.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | result | An output iterator.
  | value | The value to be removed.

Returns:
  An iterator designating the end of the resulting sequence.

Copies each element in the range ``[first,last) not equal to `value` to the range beginning at `result`. remove_copy() is stable, so the relative order of elements that are copied is unchanged.

Definition at line 1025 of file stl_algo.h.

Referenced by remove().

_OutputIterator std::remove_copy_if | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _OutputIterator | __result,
|  | _Predicate | __pred
| ) |

Copy a sequence, removing elements for which a predicate is true.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | result | An output iterator.
  | pred | A predicate.

Returns:
  An iterator designating the end of the resulting sequence.

Copies each element in the range ``[first,last) for which `pred` returns true to the range beginning at `result`.

remove_copy_if() is stable, so the relative order of elements that are copied is unchanged.

Definition at line 1062 of file stl_algo.h.

Referenced by remove_if().

_ForwardIterator std::remove_if | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | _Predicate | __pred
| ) |

Remove elements from a sequence using a predicate.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.
  | pred | A predicate.

Returns:
  An iterator designating the end of the resulting sequence.

All elements for which `pred` returns true are removed from the range ``[first,last).

remove_if() is stable, so the relative order of elements that are not removed is unchanged.

Elements between the end of the resulting sequence and `last` are still present, but their value is unspecified.

Definition at line 1135 of file stl_algo.h.

References remove_copy_if().

void std::replace | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | const _Tp & | __old_value,
|  | const _Tp & | __new_value
| ) |

Replace each occurrence of one value in a sequence with another value.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.
  | old_value | The value to be replaced.
  | new_value | The replacement value.

Returns:
  replace() returns no value.

For each iterator `i` in the range ``[first,last) if `*i` == `old_value` then the assignment `*i` = `new_value` is performed.

Definition at line 844 of file stl_algo.h.

_OutputIterator std::replace_copy | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _OutputIterator | __result,
|  | const _Tp & | __old_value,
|  | const _Tp & | __new_value
| ) |

Copy a sequence, replacing each element of one value with another value.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | result | An output iterator.
  | old_value | The value to be replaced.
  | new_value | The replacement value.

Returns:
  The end of the output sequence, `result+`(last-first).

Copies each element in the input range ``[first,last) to the output range ``[result,result+(last-first)) replacing elements equal to `old_value` with `new_value`.

Definition at line 908 of file stl_algo.h.

_OutputIterator std::replace_copy_if | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _OutputIterator | __result,
|  | _Predicate | __pred,
|  | const _Tp & | __new_value
| ) |

Copy a sequence, replacing each value for which a predicate returns true with another value.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | result | An output iterator.
  | pred | A predicate.
  | new_value | The replacement value.

Returns:
  The end of the output sequence, `result+`(last-first).

Copies each element in the range ``[first,last) to the range ``[result,result+(last-first)) replacing elements for which `pred` returns true with `new_value`.

Definition at line 942 of file stl_algo.h.

void std::replace_if | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | _Predicate | __pred,
|  | const _Tp & | __new_value
| ) |

Replace each value in a sequence for which a predicate returns true with another value.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.
  | pred | A predicate.
  | new_value | The replacement value.

Returns:
  replace_if() returns no value.

For each iterator `i` in the range ``[first,last) if `pred(*i)` is true then the assignment `*i` = `new_value` is performed.

Definition at line 875 of file stl_algo.h.

_Resetiosflags std::resetiosflags | ( | ios_base::fmtflags | __mask | ) | `[inline]`

Manipulator for `setf`.

Parameters:

  | mask | A format flags mask.

Sent to a stream object, this manipulator resets the specified flags, via stream.setf(0,mask).

Definition at line 63 of file iomanip.

void std::return_temporary_buffer | ( | _Tp * | __p | ) |

The companion to get_temporary_buffer().

Parameters:

  | p | A buffer previously allocated by get_temporary_buffer.

Returns:
  None.

Frees the memory pointed to by p.

Definition at line 122 of file memory.

void std::reverse | ( | _BidirectionalIterator | __first,
|  | _BidirectionalIterator | __last
| ) | `[inline]`

Reverse a sequence.

Parameters:

  | first | A bidirectional iterator.
  | last | A bidirectional iterator.

Returns:
  reverse() returns no value.

Reverses the order of the elements in the range ``[first,last), so that the first element becomes the last etc. For every `i` such that `0<=i<=`(last-first)/2), `reverse()` swaps `*`(first+i) and `*`(last-(i+1))

Definition at line 1463 of file stl_algo.h.

Referenced by next_permutation(), and prev_permutation().

_OutputIterator std::reverse_copy | ( | _BidirectionalIterator | __first,
|  | _BidirectionalIterator | __last,
|  | _OutputIterator | __result
| ) |

Copy a sequence, reversing its elements.

Parameters:

  | first | A bidirectional iterator.
  | last | A bidirectional iterator.
  | result | An output iterator.

Returns:
  An iterator designating the end of the resulting sequence.

Copies the elements in the range ``[first,last) to the range ``[result,result+(last-first)) such that the order of the elements is reversed. For every `i` such that `0<=i<=`(last-first), `reverse_copy()` performs the assignment `*`(result+(last-first)-i) = *(first+i). The ranges ``[first,last) and ``[result,result+(last-first)) must not overlap.

Definition at line 1489 of file stl_algo.h.

ios_base& std::right | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::right, ios_base::adjustfield). Definition at line 917 of file ios_base.h. References ios_base::adjustfield, and ios_base::right.

void std::rotate | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __middle,
|  | _ForwardIterator | __last
| ) | `[inline]`

Rotate the elements of a sequence.

Parameters:

  | first | A forward iterator.
  | middle | A forward iterator.
  | last | A forward iterator.

Returns:
  Nothing.

Rotates the elements of the range ``[first,last) by ``(middle-first) positions so that the element at `middle` is moved to `first`, the element at `middle+1` is moved to +1 and so on for each element in the range ``[first,last).

This effectively swaps the ranges ``[first,middle) and ``[middle,last).

Performs `*`(first+(n+(last-middle))%(last-first))=*(first+n) for each `n` in the range ``[0,last-first).

Definition at line 1696 of file stl_algo.h.

_OutputIterator std::rotate_copy | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __middle,
|  | _ForwardIterator | __last,
|  | _OutputIterator | __result
| ) |

Copy a sequence, rotating its elements.

Parameters:

  | first | A forward iterator.
  | middle | A forward iterator.
  | last | A forward iterator.
  | result | An output iterator.

Returns:
  An iterator designating the end of the resulting sequence.

Copies the elements of the range ``[first,last) to the range beginning at

Returns:
  , rotating the copied elements by ``(middle-first) positions so that the element at `middle` is moved to `result`, the element at `middle+1` is moved to

  +1 and so on for each element in the range ``[first,last).

Performs `*`(result+(n+(last-middle))%(last-first))=*(first+n) for each `n` in the range ``[0,last-first).

Definition at line 1729 of file stl_algo.h.

References copy().

ios_base& std::scientific | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::scientific, ios_base::floatfield). Definition at line 959 of file ios_base.h. References ios_base::floatfield, and ios_base::scientific.

_ForwardIterator1 std::search | ( | _ForwardIterator1 | __first1,
|  | _ForwardIterator1 | __last1,
|  | _ForwardIterator2 | __first2,
|  | _ForwardIterator2 | __last2,
|  | _BinaryPredicate | __predicate
| ) |

Search a sequence for a matching sub-sequence using a predicate.

Parameters:

  | first1 | A forward iterator.
  | last1 | A forward iterator.
  | first2 | A forward iterator.
  | last2 | A forward iterator.
  | predicate | A binary predicate.

Returns:
  The first iterator `i` in the range ``[first1,last1-(last2-first2)) such that `predicate`(*(i+N),*(first2+N)) is true for each `N` in the range ``[0,last2-first2), or `last1` if no such iterator exists.

Searches the range ``[first1,last1) for a sub-sequence that compares equal value-by-value with the sequence given by ``[first2,last2), using `predicate` to determine equality, and returns an iterator to the first element of the sub-sequence, or `last1` if no such iterator exists.

See also:
  search(_ForwardIter1, _ForwardIter1, _ForwardIter2, _ForwardIter2)

Definition at line 548 of file stl_algo.h.

_ForwardIterator1 std::search | ( | _ForwardIterator1 | __first1,
|  | _ForwardIterator1 | __last1,
|  | _ForwardIterator2 | __first2,
|  | _ForwardIterator2 | __last2
| ) |

Search a sequence for a matching sub-sequence.

Parameters:

  | first1 | A forward iterator.
  | last1 | A forward iterator.
  | first2 | A forward iterator.
  | last2 | A forward iterator.

Returns:
  The first iterator `i` in the range ``[first1,last1-(last2-first2)) such that `*`(i+N) == `*`(first2+N) for each `N` in the range ``[0,last2-first2), or `last1` if no such iterator exists.

Searches the range ``[first1,last1) for a sub-sequence that compares equal value-by-value with the sequence given by ``[first2,last2) and returns an iterator to the first element of the sub-sequence, or `last1` if the sub-sequence is not found.

Because the sub-sequence must lie completely within the range ``[first1,last1) it must start at a position less than `last1-`(last2-first2) where `last2-first2` is the length of the sub-sequence. This means that the returned iterator `i` will be in the range ``[first1,last1-(last2-first2))

Definition at line 476 of file stl_algo.h.

Referenced by basic_string::find().

_ForwardIterator std::search_n | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | _Integer | __count,
|  | const _Tp & | __val,
|  | _BinaryPredicate | __binary_pred
| ) |

Search a sequence for a number of consecutive values using a predicate.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.
  | count | The number of consecutive values.
  | val | The value to find.
  | binary_pred | A binary predicate.

Returns:
  The first iterator `i` in the range ``[first,last-count) such that `binary_pred`(*(i+N),val) is true for each `N` in the range ``[0,count), or `last` if no such iterator exists.

Searches the range ``[first,last) for `count` consecutive elements for which the predicate returns true.

Definition at line 678 of file stl_algo.h.

_ForwardIterator std::search_n | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | _Integer | __count,
|  | const _Tp & | __val
| ) |

Search a sequence for a number of consecutive values.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.
  | count | The number of consecutive values.
  | val | The value to find.

Returns:
  The first iterator `i` in the range ``[first,last-count) such that `*`(i+N) == `val` for each `N` in the range ``[0,count), or `last` if no such iterator exists.

Searches the range ``[first,last) for `count` consecutive elements equal to `val`.

Definition at line 625 of file stl_algo.h.

new_handler std::set_new_handler | ( | new_handler |  | ) | throw ()

| Takes a replacement handler as the argument, returns the previous handler.

terminate_handler std::set_terminate | ( | terminate_handler |  | ) | throw ()

| Takes a new handler function as an argument, returns the old function.

unexpected_handler std::set_unexpected | ( | unexpected_handler |  | ) | throw ()

| Takes a new handler function as an argument, returns the old function.

_Setbase std::setbase | ( | int | __base | ) | `[inline]`

Manipulator for `setf`.

Parameters:

  | base | A numeric base.

Sent to a stream object, this manipulator changes the `ios_base::basefield` flags to `oct`, `dec`, or `hex` when base is 8, 10, or 16, accordingly, and to 0 if base is any other value.

Definition at line 132 of file iomanip.

_Setfill<_CharT> std::setfill | ( | _CharT | __c | ) | `[inline]`

Manipulator for `fill`.

Parameters:

  | c | The new fill character.

Sent to a stream object, this manipulator calls `fill(c)` for that object.

Definition at line 174 of file iomanip.

_Setiosflags std::setiosflags | ( | ios_base::fmtflags | __mask | ) | `[inline]`

Manipulator for `setf`.

Parameters:

  | mask | A format flags mask.

Sent to a stream object, this manipulator sets the format flags to mask.

Definition at line 97 of file iomanip.

_Setprecision std::setprecision | ( | int | __n | ) | `[inline]`

Manipulator for `precision`.

Parameters:

  | n | The new precision.

Sent to a stream object, this manipulator calls `precision(n)` for that object.

Definition at line 208 of file iomanip.

_Setw std::setw | ( | int | __n | ) | `[inline]`

Manipulator for `width`.

Parameters:

  | n | The new width.

Sent to a stream object, this manipulator calls `width(n)` for that object.

Definition at line 242 of file iomanip.

ios_base& std::showbase | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::showbase). Definition at line 804 of file ios_base.h. References ios_base::showbase.

ios_base& std::showpoint | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::showpoint). Definition at line 820 of file ios_base.h. References ios_base::showpoint.

ios_base& std::showpos | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::showpos). Definition at line 836 of file ios_base.h. References ios_base::showpos.

ios_base& std::skipws | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::skipws). Definition at line 852 of file ios_base.h. References ios_base::skipws.

void std::sort | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last,
|  | _Compare | __comp
| ) | `[inline]`

Sort the elements of a sequence using a predicate for comparison.

Parameters:

  | first | An iterator.
  | last | Another iterator.
  | comp | A comparison functor.

Returns:
  Nothing.

Sorts the elements in the range ``[first,last) in ascending order, such that `comp`(*(i+1),*i) is false for every iterator `i` in the range ``[first,last-1).

The relative ordering of equivalent elements is not preserved, use `stable_sort()` if this is needed.

Definition at line 2591 of file stl_algo.h.

void std::sort | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last
| ) | `[inline]`

Sort the elements of a sequence.

Parameters:

  | first | An iterator.
  | last | Another iterator.

Returns:
  Nothing.

Sorts the elements in the range ``[first,last) in ascending order, such that `*`(i+1)<*i is false for each iterator `i` in the range ``[first,last-1).

The relative ordering of equivalent elements is not preserved, use `stable_sort()` if this is needed.

Definition at line 2557 of file stl_algo.h.

void std::sort_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last,
|  | _Compare | __comp
| ) |

Sort a heap using comparison functor.

Parameters:

  | first | Start of heap.
  | last | End of heap.
  | comp | Comparison functor to use.

This operation sorts the valid heap in the range [first,last). Comparisons are made using comp.

Definition at line 448 of file stl_heap.h.

References pop_heap().

void std::sort_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last
| ) |

Sort a heap.

Parameters:

  | first | Start of heap.
  | last | End of heap.

This operation sorts the valid heap in the range [first,last).

Definition at line 422 of file stl_heap.h.

References pop_heap().

Referenced by partial_sort(), and partial_sort_copy().

_ForwardIterator std::stable_partition | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | _Predicate | __pred
| ) |

Move elements for which a predicate is true to the beginning of a sequence, preserving relative ordering.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.
  | pred | A predicate functor.

Returns:
  An iterator `middle` such that `pred(i)` is true for each iterator `i` in the range ``[first,middle) and false for each `i` in the range ``[middle,last).

Performs the same function as `partition()` with the additional guarantee that the relative ordering of elements in each group is preserved, so any two elements `x` and `y` in the range ``[first,last) such that `pred(x)==pred`(y) will have the same relative ordering after calling `stable_partition()`.

Definition at line 1986 of file stl_algo.h.

void std::stable_sort | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last,
|  | _Compare | __comp
| ) | `[inline]`

Sort the elements of a sequence using a predicate for comparison, preserving the relative order of equivalent elements.

Parameters:

  | first | An iterator.
  | last | Another iterator.
  | comp | A comparison functor.

Returns:
  Nothing.

Sorts the elements in the range ``[first,last) in ascending order, such that `comp`(*(i+1),*i) is false for each iterator `i` in the range ``[first,last-1).

The relative ordering of equivalent elements is preserved, so any two elements `x` and `y` in the range ``[first,last) such that `comp(x,y)` is false and `comp(y,x)` is false will have the same relative ordering after calling `stable_sort()`.

Definition at line 3658 of file stl_algo.h.

void std::stable_sort | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last
| ) | `[inline]`

Sort the elements of a sequence, preserving the relative order of equivalent elements.

Parameters:

  | first | An iterator.
  | last | Another iterator.

Returns:
  Nothing.

Sorts the elements in the range ``[first,last) in ascending order, such that `*`(i+1)<*i is false for each iterator `i` in the range ``[first,last-1).

The relative ordering of equivalent elements is preserved, so any two elements `x` and `y` in the range ``[first,last) such that `x<y` is false and `y<x` is false will have the same relative ordering after calling `stable_sort()`.

Definition at line 3617 of file stl_algo.h.

void std::swap | ( | vector< _Tp, _Alloc > & | __x,
|  | vector< _Tp, _Alloc > & | __y
| ) | `[inline]`

| See std::vector::swap(). Definition at line 976 of file stl_vector.h. References vector::swap().

void std::swap | ( | set< _Key, _Compare, _Alloc > & | __x,
|  | set< _Key, _Compare, _Alloc > & | __y
| ) | `[inline]`

| See std::set::swap(). Definition at line 588 of file stl_set.h. References set::swap().

void std::swap | ( | multiset< _Key, _Compare, _Alloc > & | __x,
|  | multiset< _Key, _Compare, _Alloc > & | __y
| ) | `[inline]`

| See std::multiset::swap(). Definition at line 579 of file stl_multiset.h. References multiset::swap().

void std::swap | ( | multimap< _Key, _Tp, _Compare, _Alloc > & | __x,
|  | multimap< _Key, _Tp, _Compare, _Alloc > & | __y
| ) | `[inline]`

| See std::multimap::swap(). Definition at line 672 of file stl_multimap.h. References multimap::swap().

void std::swap | ( | map< _Key, _Tp, _Compare, _Alloc > & | __x,
|  | map< _Key, _Tp, _Compare, _Alloc > & | __y
| ) | `[inline]`

| See std::map::swap(). Definition at line 690 of file stl_map.h. References map::swap().

void std::swap | ( | list< _Tp, _Alloc > & | __x,
|  | list< _Tp, _Alloc > & | __y
| ) | `[inline]`

| See std::list::swap(). Definition at line 1238 of file stl_list.h. References list::swap().

void std::swap | ( | deque< _Tp, _Alloc > & | __x,
|  | deque< _Tp, _Alloc > & | __y
| ) | `[inline]`

| See std::deque::swap(). Definition at line 1526 of file stl_deque.h. References deque::swap().

void std::swap | ( | _Tp & | __a,
|  | _Tp & | __b
| ) | `[inline]`

Swaps two values.

Parameters:

  | a | A thing of arbitrary type.
  | b | Another thing of arbitrary type.

Returns:
  Nothing.

This is the simple classic generic implementation. It will work on any type which has a copy constructor and an assignment operator.

Definition at line 92 of file stl_algobase.h.

void std::swap | ( | basic_string< _CharT, _Traits, _Alloc > & | __lhs,
|  | basic_string< _CharT, _Traits, _Alloc > & | __rhs
| ) | `[inline]`

Swap contents of two strings.

Parameters:

  | lhs | First string.
  | rhs | Second string.

Exchanges the contents of lhs and rhs in constant time.

Definition at line 2350 of file basic_string.h.

Referenced by vector< _Node *, _Nodeptr_Alloc >::swap(), list::swap(), deque::swap(), and std::tr1::swap().

_ForwardIterator2 std::swap_ranges | ( | _ForwardIterator1 | __first1,
|  | _ForwardIterator1 | __last1,
|  | _ForwardIterator2 | __first2
| ) |

Swap the elements of two sequences.

Parameters:

  | first1 | A forward iterator.
  | last1 | A forward iterator.
  | first2 | A forward iterator.

Returns:
  An iterator equal to `first2+`(last1-first1).

Swaps each element in the range ``[first1,last1) with the corresponding element in the range ``[first2,(last1-first1)). The ranges must not overlap.

Definition at line 739 of file stl_algo.h.

References iter_swap().

void std::terminate | ( |  | ) |

| The runtime will call this function if exception handling must be abandoned for any reason. It can also be called by the user.

_CharT tolower | ( | _CharT | __c,
|  | const locale & | __loc
| ) | `[inline]`

| Convenience interface to ctype.tolower(__c). Definition at line 4574 of file locale_facets.h.

_CharT toupper | ( | _CharT | __c,
|  | const locale & | __loc
| ) | `[inline]`

| Convenience interface to ctype.toupper(__c). Definition at line 4568 of file locale_facets.h.

_OutputIterator std::transform | ( | _InputIterator1 | __first1,
|  | _InputIterator1 | __last1,
|  | _InputIterator2 | __first2,
|  | _OutputIterator | __result,
|  | _BinaryOperation | __binary_op
| ) |

Perform an operation on corresponding elements of two sequences.

Parameters:

  | first1 | An input iterator.
  | last1 | An input iterator.
  | first2 | An input iterator.
  | result | An output iterator.
  | binary_op | A binary operator.

Returns:
  An output iterator equal to `result+`(last-first).

Applies the operator to the corresponding elements in the two input ranges and assigns the results to successive elements of the output sequence. Evaluates `*`(result+N)=binary_op(*(first1+N),*(first2+N)) for each `N` in the range ``[0,last1-first1).

`binary_op` must not alter either of its arguments.

Definition at line 813 of file stl_algo.h.

_OutputIterator std::transform | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _OutputIterator | __result,
|  | _UnaryOperation | __unary_op
| ) |

Perform an operation on a sequence.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | result | An output iterator.
  | unary_op | A unary operator.

Returns:
  An output iterator equal to `result+`(last-first).

Applies the operator to each element in the input range and assigns the results to successive elements of the output sequence. Evaluates `*`(result+N)=unary_op(*(first+N)) for each `N` in the range ``[0,last-first).

`unary_op` must not alter its argument.

Definition at line 778 of file stl_algo.h.

bool std::uncaught_exception | ( |  | ) | throw ()

[18.6.4]/1: "Returns true after completing evaluation of a throw-expression until either completing initialization of the exception-declaration in the matching handler or entering `unexpected()` due to the throw; or after entering `terminate()` for any reason other than an explicit call to `terminate()`. [Note: This includes stack unwinding [15.2]. end note]"

2: "When `uncaught_exception()` is true, throwing an exception can result in a call of `terminate()` (15.5.1)."

void std::unexpected | ( |  | ) |

| The runtime will call this function if an exception is thrown which violates the function's exception specification.

_ForwardIterator std::uninitialized_copy | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _ForwardIterator | __result
| ) | `[inline]`

Copies the range [first,last) into result.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | result | An output iterator.

Returns:
  result + (first - last)

Like copy(), but does not require an initialized output range.

Definition at line 107 of file stl_uninitialized.h.

void std::uninitialized_fill | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | const _Tp & | __x
| ) | `[inline]`

Copies the value x into the range [first,last).

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | x | The source value.

Returns:
  Nothing.

Like fill(), but does not require an initialized output range.

Definition at line 169 of file stl_uninitialized.h.

void std::uninitialized_fill_n | ( | _ForwardIterator | __first,
|  | _Size | __n,
|  | const _Tp & | __x
| ) | `[inline]`

Copies the value x into the range [first,first+n).

Parameters:

  | first | An input iterator.
  | n | The number of copies to make.
  | x | The source value.

Returns:
  Nothing.

Like fill_n(), but does not require an initialized output range.

Definition at line 214 of file stl_uninitialized.h.

_ForwardIterator std::unique | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | _BinaryPredicate | __binary_pred
| ) |

Remove consecutive values from a sequence using a predicate.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.
  | binary_pred | A binary predicate.

Returns:
  An iterator designating the end of the resulting sequence.

Removes all but the first element from each group of consecutive values for which `binary_pred` returns true. unique() is stable, so the relative order of elements that are not removed is unchanged. Elements between the end of the resulting sequence and `last` are still present, but their value is unspecified.

Definition at line 1380 of file stl_algo.h.

References adjacent_find().

_ForwardIterator std::unique | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last
| ) |

Remove consecutive duplicate values from a sequence.

Parameters:

  | first | A forward iterator.
  | last | A forward iterator.

Returns:
  An iterator designating the end of the resulting sequence.

Removes all but the first element from each group of consecutive values that compare equal. unique() is stable, so the relative order of elements that are not removed is unchanged. Elements between the end of the resulting sequence and `last` are still present, but their value is unspecified.

Definition at line 1341 of file stl_algo.h.

References adjacent_find().

_OutputIterator std::unique_copy | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _OutputIterator | __result,
|  | _BinaryPredicate | __binary_pred
| ) | `[inline]`

Copy a sequence, removing consecutive values using a predicate.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | result | An output iterator.
  | binary_pred | A binary predicate.

Returns:
  An iterator designating the end of the resulting sequence.

Copies each element in the range ``[first,last) to the range beginning at `result`, except that only the first element is copied from groups of consecutive elements for which `binary_pred` returns true. unique_copy() is stable, so the relative order of elements that are copied is unchanged.

Definition at line 1308 of file stl_algo.h.

_OutputIterator std::unique_copy | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | _OutputIterator | __result
| ) | `[inline]`

Copy a sequence, removing consecutive duplicate values.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | result | An output iterator.

Returns:
  An iterator designating the end of the resulting sequence.

Copies each element in the range ``[first,last) to the range beginning at `result`, except that only the first element is copied from groups of consecutive elements that compare equal. unique_copy() is stable, so the relative order of elements that are copied is unchanged.

Definition at line 1272 of file stl_algo.h.

ios_base& std::unitbuf | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::unitbuf). Definition at line 884 of file ios_base.h. References ios_base::unitbuf.

ios_base& std::uppercase | ( | ios_base & | __base | ) | `[inline]`

| Calls base.setf(ios_base::uppercase). Definition at line 868 of file ios_base.h. References ios_base::uppercase.

const _Facet & use_facet | ( | const locale & | __loc | ) | `[inline]`

Return a facet.

use_facet looks for and returns a reference to a facet of type Facet where Facet is the template parameter. If has_facet(locale) is true, there is a suitable facet to return. It throws std::bad_cast if the locale doesn't contain a facet of type Facet.

Parameters:

  | Facet | The facet type to access.
  | locale | The locale to use.

Returns:
  Reference to facet of type Facet.

Exceptions:

  | std::bad_cast | if locale doesn't contain a facet of type Facet.

Definition at line 110 of file locale_facets.tcc.

basic_istream< _CharT, _Traits > & ws | ( | basic_istream< _CharT, _Traits > & | __is | ) |

Quick and easy way to eat whitespace.

This manipulator extracts whitespace characters, stopping when the next character is non-whitespace, or when the input sequence is empty. If the sequence is empty, `eofbit` is set in the stream, but not `failbit`.

The current locale is used to distinguish whitespace characters.

Example:

         MyClass   mc;

         std::cin >> std::ws >> mc;

will skip leading whitespace before calling operator>> on cin and your object. Note that the same effect can be achieved by creating a std::basic_istream::sentry inside your definition of operator>>.

Definition at line 1106 of file istream.tcc.

References ios_base::eofbit.

## Variable Documentation

ostream cerr

| Linked to standard error (unbuffered).

istream cin

| Linked to standard input.

ostream clog

| Linked to standard error (buffered).

ostream cout

| Linked to standard output.

wostream wcerr

| Linked to standard error (unbuffered).

wistream wcin

| Linked to standard input.

wostream wclog

| Linked to standard error (buffered).

wostream wcout

| Linked to standard output.